<?php
header("Content-type: text/css; charset: UTF-8");

session_start();

include '../include.php';
?>

/************************************************************************************
GENERAL STYLING
*************************************************************************************/
body, html, p, div, span, td, tr, table, textarea {
font: <?php echo sizecm(0.45); ?>/150% "Lucida Grande", Arial, "Lucida Sans Unicode", sans-serif;
}

body, html {
color: #000;
margin: 0;
padding: 0;
text-align: center;
background: #000;
}

hr {
margin-top: <?php echo sizecm(0.5); ?>;
margin-bottom: <?php echo sizecm(0.5); ?>;
clear: both;
}

.smallsvg {
border: 1px solid black;
width: <?php echo sizecm(5.0); ?>;
height: <?php echo sizecm(5.0); ?>;
float: right;
margin-bottom: <?php echo sizecm(0.5); ?>; 
margin-left: <?php echo sizecm(0.5); ?>; 
margin-top: 0; 
margin-right: 0; 
}

.aesthsvgcontainer {
width: <?php echo sizecm(23.8); ?>;
height: <?php echo sizecm(7.6); ?>;
text-align: justify;
-ms-text-justify: distribute-all-lines;
text-justify: distribute-all-lines;
}

.forceaesthsvgcontainer {
width: <?php echo sizecm(23.8); ?>;
height: <?php echo sizecm(11.6); ?>;
text-align: justify;
-ms-text-justify: distribute-all-lines;
text-justify: distribute-all-lines;
}

.aesthsvgcontainer:after, .forceaesthsvgcontainer:after {
content: '';
width: 100%;
display: inline-block;
font-size: 0;
line-height: 0;
}

.querysvgcontainer {
width: <?php echo sizecm(13.7); ?>;
height: <?php echo sizecm(13.7); ?>;
margin: 0 auto;
}

.threesvg {
border: 1px solid black;
width: <?php echo sizecm(7.6); ?>;
height: <?php echo sizecm(7.6); ?>;
vertical-align: top;
display: inline-block;
*display: inline;
zoom: 1;
}

.twosvg {
border: 1px solid black;
width: <?php echo sizecm(11.6); ?>;
height: <?php echo sizecm(11.6); ?>;
margin: 0;
}

.prototypesvg {
border: 1px solid black;
width: <?php echo sizecm(7); ?>;
height: <?php echo sizecm(7); ?>;
margin-bottom: <?php echo sizecm(0.5); ?>; 
margin-left: 0; 
margin-top: 0; 
margin-right: <?php echo sizecm(0.5); ?>; 
}

.centersvg {
width: <?php echo sizecm(13.7); ?>;
margin: 0 auto <?php echo sizecm(0.1); ?>;
}

.bigsvg {
border: 1px solid black;
width: <?php echo sizecm(13.7); ?>;
height: <?php echo sizecm(13.7); ?>;
margin: 0;
}

.configsvg {
border: 1px solid black;
width: <?php echo sizecm(23.3); ?>;
height: <?php echo sizecm(17.5); ?>;
margin: <?php echo sizecm(0.5); ?> 0 0;
}

.inlinesvg {
border: 0;
width: <?php echo sizecm(0.45); ?>;
height: <?php echo sizecm(0.45); ?>;
margin: 0 0 <?php echo sizecm(-0.1); ?>;
}

.inlinesvglink {
border: 0;
width: <?php echo sizecm(1.2); ?>;
height: <?php echo sizecm(0.45); ?>;
margin: 0 0 <?php echo sizecm(-0.1); ?>;
}

.main {
margin: 0 auto;
padding: <?php echo sizecm(0.15); ?> <?php echo sizecm(1.5); ?> <?php echo sizecm(0.25); ?>;
width: <?php echo sizecm(23.8); ?>;
text-align: left;
background: #fff;
}

#disablednote {
margin-left: <?php echo sizecm(0.25); ?>;
color: #f00;
}

.timenote {
    margin-top: <?php echo sizecm(0.25); ?>;
    height: <?php echo sizecm(0.85); ?>;
    float:right;
    display:block;
}

a {
text-decoration: none;
outline: none;
color: #026acb;
}
a:hover {
text-decoration: underline;
}
.centered{
text-align: center;
}

.noscript {
color: red;
}

h1, h2, h3, h4, h5, h6, h7 {
margin: 5 0 <?php echo sizecm(0.3); ?>;
color: #333;
text-align: center;
}
h1 {
font-size: 160%;
}
h2 {
font-size: 140%;
}
h3 {
font-size: 125%;
}
h4 {
font-size: 115%;
}
h5 {
font-size: 105%;
}
h6 {
font-size: 100%;
}
h7 {
display: block;
}
p {
margin: <?php echo sizecm(0.10); ?> 0;
text-align: justify;
}
.small {
font-size: 100%;
}

.emph {
font-weight: bold;
}

td {
vertical-align: top;
}

.midalign {
vertical-align: middle;
}

/* progress */
.progressoutline {
margin-left: auto;
margin-right: auto;
margin-top: 0;
margin-bottom: <?php echo sizecm(0.5); ?>; 
height: <?php echo sizecm(0.5); ?>;
width: <?php echo sizecm(9); ?>;
border: <?php echo sizecm(0.1); ?> solid #ccc;
}

.progressfill {
height: <?php echo sizecm(0.5); ?>;
background-color: #ddd;
margin-left: 0;
margin-right: auto;
}

/* forms */
form {
margin: 0;
padding: 0;
}

input[type='submit']{
width:  <?php echo sizecm(6); ?>;
}
input[type='button']{
width:  <?php echo sizecm(6); ?>;
}

input[type='button']:enabled, input[type='submit']:enabled {
background: #ccc;
border: <?php echo sizecm(0.1); ?> #000;
height: <?php echo sizepxint(1.5); ?>em;
font-size: <?php echo sizepxint(1); ?>em;
line-height: <?php echo sizepxint(1.2); ?>em;
}

input[type='button']:disabled, input[type='submit']:disabled {
background: #eee;
border: <?php echo sizecm(0.1); ?> #000;
height: <?php echo sizepxint(1.5); ?>em;
font-size: <?php echo sizepxint(1); ?>em;
line-height: <?php echo sizepxint(1.2); ?>em;
}

<?php if (true) { ?>
input[type=range] {
  width: <?php echo sizecm(9); ?>;
}
<?php } else { ?>
input[type=range] {
  -webkit-appearance: none;
  width: <?php echo sizecm(9); ?>;
  margin: <?php echo sizepx(1); ?> 0;
}
input[type=range]:focus {
  outline: none;
}
input[type=range]::-webkit-slider-runnable-track {
  width: 100%;
  height: <?php echo sizepx(8.4); ?>;
  cursor: pointer;
  background: #3071a9;
  border-radius: <?php echo sizepx(24.8); ?>;
  border: <?php echo sizepx(0.2); ?> solid #010101;
}
input[type=range]::-webkit-slider-thumb {  
  border: <?php echo sizepx(1); ?> solid #000000;
  height: <?php echo sizepx(15); ?>;
  width: <?php echo sizepx(7); ?>;
  border-radius: <?php echo sizepx(10); ?>;
  background: #ffffff;
  cursor: pointer;
  -webkit-appearance: none;
  margin-top: <?php echo sizepx(-3.5); ?>;
}
input[type=range]:focus::-webkit-slider-runnable-track {
  background: #367ebd;
}
input[type=range]::-moz-range-track {
  width: 100%;
  height: <?php echo sizepx(8.4); ?>;
  cursor: pointer;
  background: #3071a9;
  border-radius: <?php echo sizepx(24.8); ?>;
  border: <?php echo sizepx(0.2); ?> solid #010101;
}
input[type=range]::-moz-range-thumb {
  border: <?php echo sizepx(1); ?> solid #000000;
  height: <?php echo sizepx(15); ?>;
  width: <?php echo sizepx(7); ?>;
  border-radius: <?php echo sizepx(10); ?>;
  background: #ffffff;
  cursor: pointer;
}
input[type=range]::-ms-track {
  width: 100%;
  height: <?php echo sizepx(8.4); ?>;
  cursor: pointer;
  background: transparent;
  border-color: transparent;
  color: transparent;
}
input[type=range]::-ms-fill-lower {
  background: #2a6495;
  border: <?php echo sizepx(0.2); ?> solid #010101;
  border-radius: <?php echo sizepx(49.6); ?>;
}
input[type=range]::-ms-fill-upper {
  background: #3071a9;
  border: <?php echo sizepx(0.2); ?> solid #010101;
  border-radius: <?php echo sizepx(49.6); ?>;
}
input[type=range]::-ms-thumb {
  border: <?php echo sizepx(1); ?> solid #000000;
  height: <?php echo sizepx(15); ?>;
  width: <?php echo sizepx(7); ?>;
  border-radius: <?php echo sizepx(10); ?>;
  background: #ffffff;
  cursor: pointer;
  height: <?php echo sizepx(8.4); ?>;
}
input[type=range]:focus::-ms-fill-lower {
  background: #3071a9;
}
input[type=range]:focus::-ms-fill-upper {
  background: #367ebd;
}
<?php } ?>

input[type='radio'], input[type='checkbox'] {
border: <?php echo sizecm(0.1); ?> #000;
height: 1em;
width: 1em;
}

/*
 PARTICIPANT
*/

.error {
color: red;
}

.treepreftable, .forcepreftable {
width: 100%;
text-align: justify;
-ms-text-justify: distribute-all-lines;
text-justify: distribute-all-lines;
clear: both;
margin-top: <?php echo sizecm(0.1); ?>;
}

.treepreftablediv {
width: <?php echo sizecm(7.6); ?>;
text-align: center;
-ms-text-justify: distribute-all-lines;
text-justify: distribute-all-lines;
display: inline-block;
}

.treepreferenceouter {
width: <?php echo sizecm(7.6); ?>;
text-align:center;
display: inline-block;
}

.treepreftable input[type='range'] {
width: <?php echo sizecm(7.6); ?>;
margin: 0;
}

.forcepreftable input[type='range'] {
width: <?php echo sizecm(11.6); ?>;
margin:0;
}

.forcepreftablediv {
width: <?php echo sizecm(11.6); ?>;
text-align: center;
-ms-text-justify: distribute-all-lines;
text-justify: distribute-all-lines;
display: inline-block;
}

.forcepreferenceouter {
width: <?php echo sizecm(11.6); ?>;
text-align:center;
display: inline-block;
}

.preferenceinner {
display: inline-block;
margin: 0 auto;
width: 20%;
}

.preferenceleft {
float: left;
text-align: left;
width: 40%;
}

.preferenceright {
float: right;
text-align: right;
width: 40%;
}

.preftable:after, .treepreftable:after, .forcepreftable:after, .treepreftablediv:after{
content: '';
width: 100%;
display: inline-block;
font-size: 0;
line-height: 0
}

/*
ANSWERS
*/

.answertable {
width: 100%;
clear: both;
}

.answertableleft {
text-align: left;
width: 35%;
}

.answertablemid {
text-align: center;
width: 30%;
}

.answertableright {
text-align: right;
width: 35%;
}

.flashing {
animation-name: flash;
animation-duration: 2s;
animation-iteration-count: infinite;
animation-direction: alternate;
animation-timing-function: linear;

-webkit-animation-name: flash;
-webkit-animation-duration: 2s;
-webkit-animation-iteration-count: infinite;
-webkit-animation-direction: alternate;
-webkit-animation-timing-function: linear;
}

@keyframes flash {
  0% {opacity: 1.0;}
 25% {opacity: 0.9;}
 50% {opacity: 0.7;}
 75% {opacity: 0.4;}
100% {opacity: 0.1;}
}

@-webkit-keyframes flash {
  0% {opacity: 1.0;}
 25% {opacity: 0.9;}
 50% {opacity: 0.7;}
 75% {opacity: 0.4;}
100% {opacity: 0.1;}
}

/*
GRAPH DRAWING
*/

rect.rank0 , rect.rect{
fill: #F7F7F7;
}

rect.rank1 {
fill: #cce6cc;
}

rect.rank2 {
fill: #ffffcc;
}

rect.rank3 {
fill: #ffcccc;
}

.ranktext {
font-family: sans-serif;
stroke: black;
fill: gray;
opacity:.2;
font-weight: bold;
-webkit-touch-callout: none;
-webkit-user-select: none;
-khtml-user-select: none;
-moz-user-select: none;
-ms-user-select: none;
user-select: none;
cursor: default;
}

.frame {
stroke-linecap:round;stroke-linejoin:round;
stroke-width: <?php echo sizepxint(2); ?>;
stroke: none;
fill: none;
}

.frameInvalid {
stroke-linecap:round;stroke-linejoin:round;
stroke-width: <?php echo sizepxint(2); ?>;
stroke: red;
fill: none;
}

.node {
stroke-linecap:round;stroke-linejoin:round;
stroke-width: <?php echo sizepxint(1.6); ?>;
stroke: black;
fill: #8da0cb;
}

.nodeHighlight {
stroke: none;
fill: skyblue;
}

.nodeHighlightWrong {
stroke: none;
fill: salmon;
}

.nodeSelect {
stroke: none;
fill: lime;
}

.nodeStartEnd {
stroke: black;
fill: none;
}

.node .nodeClickArea {
stroke: none;
fill: none;
}

.pathcounttext {
font-family: sans-serif;
font-size: <?php echo sizepxint(40); ?>;
stroke: none;
fill: skyblue;
opacity: 0.85;
font-weight: bold;
}

.disttext {
font-family: sans-serif;
font-size: <?php echo sizepxint(15); ?>;
stroke: none;
fill: #8da0cb;
opacity: 0.85;
font-weight: bold;
}

.linkHighlight {
stroke-linecap:round;stroke-linejoin:round;
stroke-width: <?php echo sizepxint(10); ?>;
stroke: skyblue;
opacity: 0.85;
fill: none;
}

.linkHighlightWrong {
stroke-linecap:round;stroke-linejoin:round;
stroke-width: <?php echo sizepxint(10); ?>;
stroke: salmon;
opacity: 0.85;
fill: none;
}

.linkSelect {
stroke-linecap:round;stroke-linejoin:round;
stroke-width: <?php echo sizepxint(10); ?>;
stroke: lime;
opacity: 0.85;
fill: none;
}

.linkNormal {
stroke-linecap:round;stroke-linejoin:round;
stroke-width: <?php echo sizepxint(1.6); ?>;
stroke: black;
fill: none;
}

.linkHalo, .linkHalo0, .linkHalo1, .linkHalo2, .linkHalo3 {
stroke-linecap: round;
stroke-linejoin: round;
stroke-width: <?php echo sizepxint(3.9); ?>;
fill: none;
}

.linkHalo, .linkHalo0 {
stroke: white;
}

.linkHalo1 {
stroke: #cce6cc;
}

.linkHalo2 {
stroke: #ffffcc;
}

.linkHalo3 {
stroke: #ffcccc;
}

/*
STROKE COLORS
*/

.strokeBlue {
stroke: blue;
}

.strokeLightBlue {
stroke: #8da0cb;
}

.strokeLightRed {
stroke: #fc8d62;
}

.strokeRed {
stroke: red;
}

.strokeGreen {
stroke: green;
}

.strokeNone {
stroke: none;
}

.strokeWhite {
stroke: white;
}

.strokeBlack {
stroke: black;
}

/*
STROKE WIDTHS
*/

.stokeThin {
stroke-width: <?php echo sizepxint(1); ?>;
stroke-linecap:round;stroke-linejoin:round;
}

.strokeMedium {
stroke-width: <?php echo sizepxint(2); ?>;
stroke-linecap:round;stroke-linejoin:round;
}

.strokeHeavy {
stroke-width: <?php echo sizepxint(4.5); ?>;
stroke-linecap:round;stroke-linejoin:round;
}

/*
FILL COLORS
*/

.fillBlue {
fill: blue;
}

.fillLightBlue {
fill: #8da0cb;
}

.fillLightRed {
fill: #fc8d62;
}

.fillLightGreen {
fill: #82cb88;
}

.fillRed {
fill: red;
}

.fillGreen {
fill: green;
}

.fillNone {
fill: none;
}

.fillWhite {
fill: white;
}

.fillBlack {
fill: black;
}