var treealgos = ["FewSeg", "Tidier", "Quad"];
var forcealgos = ["FDFS", "FD"];

var duration = 4000;
var step = 20;

function treestackchart(container, file, width, height, scale, fragment, fragmentsplit) {
    d3.csv("data/"+file, function(error,data) {
        var g = d3.select("#"+container);
        var boxes = [];
        for (var i = 0; i < 3; i++) {
            boxes[i] = g.append("rect")
                .attr("id",container+"-"+i)
                .attr("class","barchart"+i)
                .attr("x",0)
                .attr("y",i / 3 * height)
                .attr("width",width)
                .attr("height",1 / 3 * height);
        }

        Reveal.addEventListener( 'fragmentshown', function( event ) {
            // event.previousSlide, event.currentSlide, event.indexh, event.indexv
            if (event.fragment.getAttribute('id') === fragment) {
                // animate
                var datascale = d3.scaleLinear()
                    .domain([0,data.length])
                    .range([0,duration]);
                var interdata = [[],[],[]];
                for (var i = 0; i < data.length; i++) {
                    interdata[0].push(data[i][treealgos[0]]);
                    interdata[1].push(data[i][treealgos[1]]);
                    interdata[2].push(data[i][treealgos[2]]);
                }
                var interpolator = [d3.interpolateBasis(interdata[0]),
                    d3.interpolateBasis(interdata[1]),
                    d3.interpolateBasis(interdata[2])];
                var trans = [boxes[0], boxes[1], boxes[2]];
                
                for (var i = step; i <= duration; i+= step) {
                    trans[0] = trans[0].transition()
                        .duration(function() {
                            return step;
                        })
                        .attr("height",function() {
                            return interpolator[0](i / duration) / scale * height;
                        });
                    trans[1] = trans[1].transition()
                        .duration(function() {
                            return step;
                        })
                        .attr("y",function() {
                            return interpolator[0](i / duration) / scale  * height;
                        })
                        .attr("height",function() {
                            return interpolator[1](i / duration) / scale  * height;
                        });
                    trans[2] = trans[2].transition()
                        .duration(function() {
                            return step;
                        })
                        .attr("y",function() {
                            return interpolator[0](i / duration) / scale  * height + interpolator[1](i / duration) / scale  * height;
                        })
                        .attr("height",function() {
                            return interpolator[2](i / duration) / scale  * height;
                        });
                }
            }
        } );

        Reveal.addEventListener( 'fragmenthidden', function( event ) {
            // event.previousSlide, event.currentSlide, event.indexh, event.indexv
            if (event.fragment.getAttribute('id') === fragment) {
                for (var i = 0; i < 3; i++) {
                    boxes[i].transition()
                        .attr("x",0)
                        .attr("y",i / 3 * height)
                        .attr("width",width)
                        .attr("height",1 / 3 * height);
                }
            }
        } );

        Reveal.addEventListener( 'fragmentshown', function( event ) {
            // event.previousSlide, event.currentSlide, event.indexh, event.indexv
            if (event.fragment.getAttribute('id') === fragmentsplit) {
                // animate
                boxes[0].transition()
                    .duration(1000)
                    .attr("height",data[data.length-1][treealgos[0]] * height)
                    .attr("y",height * (1 - data[data.length-1][treealgos[0]] / scale ));
                boxes[1].transition()
                    .duration(1000)
                    .attr("x",width)
                    .attr("height",data[data.length-1][treealgos[1]] * height)
                    .attr("y",height * (1 - data[data.length-1][treealgos[1]] / scale ));
                boxes[2].transition()
                    .duration(1000)
                    .attr("x",2*width)
                    .attr("y",data[data.length-1][treealgos[0]] / scale  * height + data[data.length-1][treealgos[1]] / scale  * height)
                    .attr("height",data[data.length-1][treealgos[2]] / scale  * height);
            }
        } );

        Reveal.addEventListener( 'fragmenthidden', function( event ) {
            // event.previousSlide, event.currentSlide, event.indexh, event.indexv
            if (event.fragment.getAttribute('id') === fragment+"-tobar") {
                // animate
                boxes[0].transition()
                    .duration(1000)
                    .attr("x",0)
                    .attr("y",0)
                    .attr("height",data[data.length-1][treealgos[0]] / scale  * height);
                boxes[1].transition()
                    .duration(1000)
                    .attr("x",0)
                    .attr("y",data[data.length-1][treealgos[0]] * height)
                    .attr("height",data[data.length-1][treealgos[1]] / scale  * height);
                boxes[2].transition()
                    .duration(1000)
                    .attr("y",data[data.length-1][treealgos[0]] / scale  * height + data[data.length-1][treealgos[1]] / scale  * height)
                    .attr("height",data[data.length-1][treealgos[2]] / scale  * height);
            }
        } );

    })
}











function updateTreeChart(container, file, height, scale) {
    d3.csv("data/"+file, function(error,data) {
        var g = d3.select("#"+container);
        var boxes = [];
        for (var i = 0; i < 3; i++) {
            boxes[i] = g.select("#" + container+"-"+i);
        }
        
        var datascale = d3.scaleLinear()
            .domain([0,data.length])
            .range([0,duration]);
        var interdata = [[],[],[]];
        for (var i = 0; i < data.length; i++) {
            interdata[0].push(data[i][treealgos[0]]);
            interdata[1].push(data[i][treealgos[1]]);
            interdata[2].push(data[i][treealgos[2]]);
        }
        var interpolator = [d3.interpolateBasis(interdata[0]),
            d3.interpolateBasis(interdata[1]),
            d3.interpolateBasis(interdata[2])];
        var trans = [boxes[0], boxes[1], boxes[2]];
        
        for (var i = step; i <= duration; i+= step) {
            trans[0] = trans[0].transition()
                .duration(function() {
                    return step;
                })
                .attr("y",function() {
                    return (1 - interpolator[0](i / duration) / scale) * height;
                })
                .attr("height",function() {
                    return interpolator[0](i / duration) / scale * height;
                });
            trans[1] = trans[1].transition()
                .duration(function() {
                    return step;
                })
                .attr("y",function() {
                    return (1 - interpolator[1](i / duration) / scale) * height;
                })
                .attr("height",function() {
                    return interpolator[1](i / duration) / scale  * height;
                });
            trans[2] = trans[2].transition()
                .duration(function() {
                    return step;
                })
                .attr("y",function() {
                    return (1 - interpolator[2](i / duration) / scale) * height;
                })
                .attr("height",function() {
                    return interpolator[2](i / duration) / scale  * height;
                });
        }

    })
}









function resetTreeChart(container, file, height, scale) {
    d3.csv("data/"+file, function(error,data) {
        var g = d3.select("#"+container);
        var boxes = [];
        for (var i = 0; i < 3; i++) {
            boxes[i] = g.select("#" + container+"-"+i);
        }
        
        var step = duration / data.length;
        var trans = [boxes[0], boxes[1], boxes[2]];
        var d = data[0];
        boxes[0].transition()
            .attr("y",function() {
                return (1 - d[treealgos[0]] / scale) * height;
            })
            .attr("height",function() {
                return d[treealgos[0]] / scale * height;
            });
        boxes[1].transition()
            .attr("y",function() {
                return (1 - d[treealgos[1]] / scale) * height;
            })
            .attr("height",function() {
                return d[treealgos[1]] / scale  * height;
            });
        boxes[2].transition()
            .attr("y",function() {
                return (1 - d[treealgos[2]] / scale) * height;
            })
            .attr("height",function() {
                return d[treealgos[2]] / scale  * height;
            });
    })
}









function forcestackchart(container, file, width, height, scale, fragment) {
    d3.csv("data/"+file, function(error,data) {
        var g = d3.select("#"+container);
        var boxes = [];
        console.log(data.length);
        boxes[0] = g.append("rect")
            .attr("id",container+"-0")
            .attr("class","barchart0")
            .attr("x",0)
            .attr("y",0)
            .attr("width",width)
            .attr("height",height / 2);
        boxes[1] = g.append("rect")
            .attr("id",container+"-1")
            .attr("class","barchart1")
            .attr("x",0)
            .attr("y",height / 2)
            .attr("width",width)
            .attr("height",height / 2);

        Reveal.addEventListener( 'fragmentshown', function( event ) {
            // event.previousSlide, event.currentSlide, event.indexh, event.indexv
            if (event.fragment.getAttribute('id') === fragment) {
                // animate
                
                var datascale = d3.scaleLinear()
                    .domain([0,data.length])
                    .range([0,duration]);
                var interdata = [[],[]];
                for (var i = 0; i < data.length; i++) {
                    interdata[0].push(data[i][forcealgos[0]]);
                    interdata[1].push(data[i][forcealgos[1]]);
                }
                var interpolator = [d3.interpolateBasis(interdata[0]),
                    d3.interpolateBasis(interdata[1])];
                var trans = [boxes[0], boxes[1]];
                
                for (var i = step; i <= duration; i+= step) {
                    trans[0] = trans[0].transition()
                        .duration(function() {
                            return step;
                        })
                        .attr("height",function() {
                            return interpolator[0](i / duration) / scale * height;
                        });
                    trans[1] = trans[1].transition()
                        .duration(function() {
                            return step;
                        })
                        .attr("y",function() {
                            return  interpolator[0](i / duration) / scale  * height;
                        })
                        .attr("height",function() {
                            return  interpolator[1](i / duration) / scale  * height;
                        });
                }
            }
        } );

        Reveal.addEventListener( 'fragmenthidden', function( event ) {
            // event.previousSlide, event.currentSlide, event.indexh, event.indexv
            if (event.fragment.getAttribute('id') === fragment) {
                boxes[0].transition()
                    .attr("x",0)
                    .attr("y",0)
                    .attr("width",width)
                    .attr("height",height / 2);
                boxes[1].transition()
                    .attr("x",0)
                    .attr("y",height / 2)
                    .attr("width",width)
                    .attr("height",height / 2);
            }
        } );

    })
}












function barchart(container, file, width, height, scale, fragment, id) {
    d3.csv("data/"+file, function(error,data) {
        var g = d3.select("#"+container);
        var box = g.append("rect")
            .attr("id",container+"-"+id)
            .attr("class","barchart"+id)
            .attr("x",0)
            .attr("y",height)
            .attr("width",width)
            .attr("height",0);
        var maxval = g.append("line")
            .attr("id",container+"-"+id+"-maxval")
            .attr("class","barchartline")
            .attr("x1",width / 4)
            .attr("y1",height)
            .attr("x2",width * 3 / 4)
            .attr("y2",height);
        var minval = g.append("line")
            .attr("id",container+"-"+id+"-minval")
            .attr("class","barchartline")
            .attr("x1",width / 4)
            .attr("y1",height)
            .attr("x2",width * 3 / 4)
            .attr("y2",height);
        var valdist = g.append("line")
            .attr("id",container+"-"+id+"-valdist")
            .attr("class","barchartline")
            .attr("x1",width / 2)
            .attr("y1",height)
            .attr("x2",width / 2)
            .attr("y2",height);

        Reveal.addEventListener( 'fragmentshown', function( event ) {
            // event.previousSlide, event.currentSlide, event.indexh, event.indexv
            if (event.fragment.getAttribute('id') === fragment) {
                // animate
                
                var datascale = d3.scaleLinear()
                    .domain([0,data.length])
                    .range([0,duration]);
                var interdata = {"AVG" : [], "MIN": [], "MAX": []};
                for (var i = 0; i < data.length; i++) {
                    interdata.AVG.push(data[i].AVG);
                    interdata.MIN.push(data[i].MIN);
                    interdata.MAX.push(data[i].MAX);
                }
                var interpolator = {"AVG" : d3.interpolateBasis(interdata.AVG),
                    "MIN" : d3.interpolateBasis(interdata.MIN),
                    "MAX" : d3.interpolateBasis(interdata.MAX)};

                var boxtrans = box, maxvaltrans = maxval, minvaltrans = minval, valdisttrans = valdist;
                
                for (var i = step; i <= duration; i+= step) {
                    boxtrans = boxtrans.transition()
                        .duration(function() {
                            return step;
                        })
                        .attr("y", function() {
                            return (scale - interpolator.AVG(i / duration)) / scale * height;
                        })
                        .attr("height",function() {
                            return interpolator.AVG(i / duration) / scale * height;
                        });
                    maxvaltrans = maxvaltrans.transition()
                        .duration(function() {
                            return step;
                        })
                        .attr("y1",function() {
                            return (scale - interpolator.MAX(i / duration)) / scale * height;
                        })
                        .attr("y2",function() {
                            return (scale - interpolator.MAX(i / duration)) / scale * height;
                        });
                    minvaltrans = minvaltrans.transition()
                        .duration(function() {
                            return step;
                        })
                        .attr("y1",function() {
                            return (scale - interpolator.MIN(i / duration)) / scale * height;
                        })
                        .attr("y2",function() {
                            return (scale - interpolator.MIN(i / duration)) / scale * height;
                        });
                    valdisttrans = valdisttrans.transition()
                        .duration(function() {
                            return step;
                        })
                        .attr("y1",function() {
                            return (scale - interpolator.MAX(i / duration)) / scale * height;
                        })
                        .attr("y2",function() {
                            return (scale - interpolator.MIN(i / duration)) / scale * height;
                        });
                }
            }
        } );

        Reveal.addEventListener( 'fragmenthidden', function( event ) {
            // event.previousSlide, event.currentSlide, event.indexh, event.indexv
            if (event.fragment.getAttribute('id') === fragment) {
                box.attr("y",height)
                    .attr("height",0);
                maxval.attr("y1",height)
                    .attr("y2",height);
                minval.attr("y1",height)
                    .attr("y2",height);
                valdist.attr("y1",height)
                    .attr("y2",height);
            }
        } );

    })
}



