var links = null, nodes = null;
var linksHighlight = null, nodeshighlight = null;

function handleNodeClick(d) {

    if (d.index === graph.markSource) {
        graph.markSource = graph.markTarget;
        graph.markTarget = -1;
    } else if (d.index === graph.markTarget) {
        graph.markTarget = -1;
    } else if (graph.markSource < 0) {
        graph.markSource = d.index;
    } else {
        graph.markTarget = d.index;
    }

    markPaths(graph);

    redraw();
}

function redraw() {
    initNodesAndLinks();
}

function initNodesAndLinks() {


    // calculate the transformation
    var minx = Number.POSITIVE_INFINITY;
    var maxx = Number.NEGATIVE_INFINITY;
    var miny = Number.POSITIVE_INFINITY;
    var maxy = Number.NEGATIVE_INFINITY;

    graph.nodes.forEach(function (d) {
        minx = Math.min(minx, d.x);
        maxx = Math.max(maxx, d.x);
        miny = Math.min(miny, d.y);
        maxy = Math.max(maxy, d.y);
    });

    var scale = (width - 80) / Math.max(maxx - minx, maxy - miny);
    var xtrans = - minx * scale + 40 + (width - 80 - maxx * scale + minx * scale) / 2;
    var ytrans = - miny * scale + 40 + (width - 80 - maxy * scale + miny * scale) / 2;

    graph.nodes.forEach(function (d) {
        d.drawx = xtrans + scale * d.x;
        d.drawy = ytrans + scale * d.y;
    });

    svgnodes.selectAll(".node").remove();
    nodes = svgnodes.selectAll(".node")
            .data(graph.nodes);
    nodes.enter().append("circle")
            .attr("class", "node")
            .attr("r", noderad)
            .attr("nodeindex", function (d) {
                return d.index;
            })
            .attr("transform", function(d) {
                return "translate(" + d.drawx + "," + d.drawy + ")";
            })
            .on("click", handleNodeClick);

    var haloed = document.getElementById('haloes').checked;
    var linkdata;
    if (haloed) {
        linkdata = [];
        graph.links.forEach(function (d) {
            linkdata.push(d);
            linkdata.push(d);
        });
    } else {
        linkdata = graph.links;
    }

    svglinks.selectAll(".link").remove();

    links = svglinks.selectAll(".link")
            .data(linkdata);
    links.enter().append("line")
            .attr("class", function (d, i) {
                if (haloed && i % 2 === 0) {
                    return "link linkHalo";
                } else {
                    return "link linkNormal";
                }
            })
            .attr("x1", function(d) { return d.source.drawx; })
            .attr("y1", function(d) { return d.source.drawy; })
            .attr("x2", function(d) { return d.target.drawx; })
            .attr("y2", function(d) { return d.target.drawy; });

    var highlight = [];
    if (graph.markSource >= 0) {
        var n = graph.nodes[graph.markSource];
        highlight.push(n);
    }
    if (graph.markTarget >= 0) {
        var n = graph.nodes[graph.markTarget];
        highlight.push(n);
    }

    svghighlight.selectAll(".nodehighlight").remove()
    nodeshighlight = svghighlight.selectAll(".nodehighlight")
            .data(highlight);
    nodeshighlight.enter().append("circle")
            .attr("class", "nodehighlight")
            .attr("r", highlightrad)
            .attr("transform", function(d) {
                    return "translate(" + d.drawx + "," + d.drawy + ")";
                })

    var linkhighlight = [];

    if (document.getElementById('markpath').checked) {
        for (var i = 0; i < graph.links.length; i++) {
            if (graph.links[i].marked) {
                linkhighlight.push(graph.links[i]);
            }
        }
    }

    svghighlight.selectAll(".link").remove()
    linksHighlight = svghighlight.selectAll(".link")
            .data(linkhighlight);
    linksHighlight.enter().append("line")
            .attr("class", "link linkHighlight")
            .attr("x1", function(d) { return d.source.drawx; })
            .attr("y1", function(d) { return d.source.drawy; })
            .attr("x2", function(d) { return d.target.drawx; })
            .attr("y2", function(d) { return d.target.drawy; });
}
