function handleNodeClick(graph,svg,vertices,edges,adjList,d) {

    if (d.id === graph.markSource) {
        graph.markSource = graph.markTarget;
        unselect(svg,d);
        graph.markTarget = -1;
    } else if (d.id === graph.markTarget) {
        unselect(svg,d);
        graph.markTarget = -1;
    } else if (graph.markSource < 0) {
        selectNodeFP(svg,d);
        graph.markSource = d.id;
    } else {
        if (graph.markTarget >= 0)
            unselect(svg,vertices[graph.markTarget]);
        selectNodeFP(svg,d);
        graph.markTarget = d.id;
    }
}


function selectNodeFP(svg,v) {
    v.selected = true;
    // don't update path degree here because it's done at the link
    svg.select("#nodesSelected")
        .append("circle")
        .attr("class", "nodeSelect")
        .attr("id", "ns" + v.id)
        .attr("transform", "translate(" + v.x + "," + v.y + ")")
        .attr("r", nodeSize)
        .transition()
        .attr("r", startendSize);
}

function unselect(svg,v) {
    v.selected = false;
    svg.select("#nodesSelected")
        .select("#ns" + v.id)
        .transition()
        .attr("r", startendSize)
        .remove();
}