function introtree() {
    d3.json("data/introtree.json", function (error, graph) {
        var vertices = [];
        var edges = [];
        var svg = d3.select("#introtreesvg");
        initGraph(graph, vertices, edges, 400, 400);
        basicLayout(svg, vertices, edges);


        var nsegments = d3.select("#intro-nsegments");

        Reveal.addEventListener( 'fragmentshown', function( event ) {
            var id = event.fragment.getAttribute('id');
            switch(id) {
                case 'introtree-1':
                    // highlight edges
                    highlightNode(svg,vertices[0]);
                    highlightNode(svg,vertices[2]);
                    highlightNode(svg,vertices[6]);
                    highlightNode(svg,vertices[11]);
                    highlightLink(svg,edges[1]);
                    highlightLink(svg,edges[5]);
                    highlightLink(svg,edges[10]);
                    nsegments.text(19);
                    break;
                case 'introtree-2':
                    highlightNode(svg,vertices[17]);
                    highlightLink(svg,edges[16]);
                    break;
                case 'introtree-3':
                    vertices[17].x = graph.xtrans + graph.scale * 7;
                    nsegments.text(18);
                    updateDrawing(svg);
                    break;
                case 'introtree-4':
                    clearHighlights(svg,edges);
                    highlightNode(svg,vertices[0]);
                    highlightNode(svg,vertices[1]);
                    highlightNode(svg,vertices[3]);
                    highlightNode(svg,vertices[4]);
                    highlightNode(svg,vertices[8]);
                    highlightLink(svg,edges[0]);
                    highlightLink(svg,edges[2]);
                    highlightLink(svg,edges[3]);
                    highlightLink(svg,edges[7]);
                    break;
                case 'introtree-5':
                    vertices[1].x = vertices[5].x;
                    vertices[1].y = vertices[0].y;
                    vertices[3].x = vertices[7].x;
                    vertices[3].y = vertices[0].y;
                    vertices[4].y = vertices[0].y;
                    vertices[8].y = vertices[0].y;
                    updateDrawing(svg);
                    nsegments.text(17);
                    break;
                case 'introtree-6':
                    clearHighlights(svg,edges);
                    highlightNode(svg,vertices[2]);
                    highlightNode(svg,vertices[7]);
                    highlightNode(svg,vertices[15]);
                    highlightNode(svg,vertices[21]);
                    highlightLink(svg,edges[6]);
                    highlightLink(svg,edges[14]);
                    highlightLink(svg,edges[20]);
                    break;
                case 'introtree-7':
                    vertices[21].x = 2 * vertices[21].x - vertices[7].x;
                    updateDrawing(svg);
                    nsegments.text(15);
                    break;
                case 'introtree-8':
                    clearHighlights(svg,edges);
                    highlightNode(svg,vertices[7]);
                    highlightNode(svg,vertices[12]);
                    highlightNode(svg,vertices[14]);
                    highlightNode(svg,vertices[20]);
                    highlightLink(svg,edges[11]);
                    highlightLink(svg,edges[13]);
                    highlightLink(svg,edges[19]);
                    break;
                case 'introtree-9':
                    vertices[14].x = (vertices[20].x + vertices[7].x) / 2;
                    vertices[12].y = 2*vertices[7].y - vertices[12].y;
                    updateDrawing(svg);
                    nsegments.text(13);
                    break;
                case 'introtree-10':
                    clearHighlights(svg,edges);
                    highlightNode(svg,vertices[1]);
                    highlightNode(svg,vertices[5]);
                    highlightNode(svg,vertices[10]);
                    highlightNode(svg,vertices[7]);
                    highlightNode(svg,vertices[13]);
                    highlightNode(svg,vertices[19]);
                    highlightLink(svg,edges[4]);
                    highlightLink(svg,edges[9]);
                    highlightLink(svg,edges[12]);
                    highlightLink(svg,edges[18]);
                    break;
                case 'introtree-11':
                    vertices[10].x = vertices[5].x;
                    vertices[19].x = vertices[13].x;
                    updateDrawing(svg);
                    nsegments.text(11);
                    break;
                case 'introtree-12':
                    clearHighlights(svg,edges);
                    break;
                case 'introtree-13':
                    vertices.forEach(function(v) {
                        v.savex = v.x;
                        v.savey = v.y;
                    });
                    vertices[1].x = graph.xtrans + graph.scale * 5;
                    vertices[4].x = graph.xtrans + graph.scale * 3;
                    vertices[5].x = vertices[1].x;
                    vertices[5].y = vertices[2].y;
                    vertices[10].x = vertices[1].x;
                    vertices[10].y = vertices[6].y;
                    vertices[9].x = vertices[4].x;
                    vertices[9].y = vertices[5].y;
                    vertices[16].x = vertices[1].x;
                    vertices[16].y = vertices[11].y;
                    vertices[3].x = vertices[0].x;
                    vertices[3].y = graph.ytrans + graph.scale * 0;
                    vertices[8].x = vertices[0].x;
                    vertices[8].y = graph.ytrans + graph.scale * (-2);
                    vertices[7].x = graph.xtrans + graph.scale * 11;
                    vertices[7].y = vertices[2].y;
                    vertices[12].x = graph.xtrans + graph.scale * 9;
                    vertices[12].y = vertices[0].y;
                    vertices[14].x = graph.xtrans + graph.scale * 13;
                    vertices[14].y = vertices[6].y;
                    vertices[20].x = graph.xtrans + graph.scale * 15;
                    vertices[20].y = vertices[11].y;
                    vertices[13].x = vertices[7].x;
                    vertices[13].y = vertices[6].y;
                    vertices[19].x = vertices[7].x;
                    vertices[19].y = vertices[11].y;
                    vertices[18].x = vertices[12].x;
                    vertices[18].y = vertices[13].y;
                    vertices[15].x = vertices[14].x;
                    vertices[15].y = vertices[7].y;
                    vertices[21].x = vertices[20].x;
                    vertices[21].y = vertices[7].y;
                    updateDrawing(svg);
                    break;


            }
        } );

        iter = 1;
        Reveal.addEventListener( 'fragmenthidden', function( event ) {
            var id = event.fragment.getAttribute('id');
            switch(id) {
                case 'introtree-1':
                    clearHighlights(svg,edges);
                    nsegments.text(21);
                    break;
                case 'introtree-2':
                    unhighlightNode(svg,vertices[17]);
                    unhighlight(svg,edges[16]);
                    break;
                case 'introtree-3':
                    vertices[17].x = graph.xtrans + graph.scale * graph.nodes[17].x;
                    updateDrawing(svg);
                    nsegments.text(19);
                    break;
                case 'introtree-4':
                    clearHighlights(svg,edges);
                    highlightNode(svg,vertices[0]);
                    highlightNode(svg,vertices[2]);
                    highlightNode(svg,vertices[6]);
                    highlightNode(svg,vertices[11]);
                    highlightNode(svg,vertices[17]);
                    highlightLink(svg,edges[1]);
                    highlightLink(svg,edges[5]);
                    highlightLink(svg,edges[10]);
                    highlightLink(svg,edges[16]);
                    break;
                case 'introtree-5':
                    vertices[1].x = graph.xtrans + graph.scale * graph.nodes[1].x;
                    vertices[1].y = graph.ytrans + graph.scale * graph.nodes[1].y;
                    vertices[3].x = graph.xtrans + graph.scale * graph.nodes[3].x;
                    vertices[3].y = graph.ytrans + graph.scale * graph.nodes[3].y;
                    vertices[4].y = graph.ytrans + graph.scale * graph.nodes[4].y;
                    vertices[8].y = graph.ytrans + graph.scale * graph.nodes[8].y;
                    updateDrawing(svg);
                    nsegments.text(18);
                    break;
                case 'introtree-6':
                    clearHighlights(svg,edges);
                    highlightNode(svg,vertices[0]);
                    highlightNode(svg,vertices[1]);
                    highlightNode(svg,vertices[3]);
                    highlightNode(svg,vertices[4]);
                    highlightNode(svg,vertices[8]);
                    highlightLink(svg,edges[0]);
                    highlightLink(svg,edges[2]);
                    highlightLink(svg,edges[3]);
                    highlightLink(svg,edges[7]);
                    break;
                case 'introtree-7':
                    vertices[21].x = graph.xtrans + graph.scale * graph.nodes[21].x;
                    updateDrawing(svg);
                    nsegments.text(17);
                    break;
                case 'introtree-8':
                    clearHighlights(svg,edges);
                    highlightNode(svg,vertices[2]);
                    highlightNode(svg,vertices[7]);
                    highlightNode(svg,vertices[15]);
                    highlightNode(svg,vertices[21]);
                    highlightLink(svg,edges[6]);
                    highlightLink(svg,edges[14]);
                    highlightLink(svg,edges[20]);
                    break;
                case 'introtree-9':
                    vertices[14].x = graph.xtrans + graph.scale * graph.nodes[14].x;
                    vertices[12].y = graph.ytrans + graph.scale * graph.nodes[12].y;
                    updateDrawing(svg);
                    nsegments.text(15);
                    break;
                case 'introtree-10':
                    clearHighlights(svg,edges);
                    highlightNode(svg,vertices[7]);
                    highlightNode(svg,vertices[12]);
                    highlightNode(svg,vertices[14]);
                    highlightNode(svg,vertices[20]);
                    highlightLink(svg,edges[11]);
                    highlightLink(svg,edges[13]);
                    highlightLink(svg,edges[19]);
                    break;
                case 'introtree-11':
                    vertices[10].x = graph.xtrans + graph.scale * graph.nodes[10].x;
                    vertices[19].x = graph.xtrans + graph.scale * graph.nodes[19].x;
                    updateDrawing(svg);
                    nsegments.text(13);
                    break;
                case 'introtree-12':
                    clearHighlights(svg,edges);
                    highlightNode(svg,vertices[1]);
                    highlightNode(svg,vertices[5]);
                    highlightNode(svg,vertices[10]);
                    highlightNode(svg,vertices[7]);
                    highlightNode(svg,vertices[13]);
                    highlightNode(svg,vertices[19]);
                    highlightLink(svg,edges[4]);
                    highlightLink(svg,edges[9]);
                    highlightLink(svg,edges[12]);
                    highlightLink(svg,edges[18]);
                    break;
                case 'introtree-13':
                    vertices.forEach(function(v) {
                        v.x = v.savex;
                        v.y = v.savey;
                    });
                    updateDrawing(svg);
                    break;
            }
        } );

    });

}





function forcealgo() {
    d3.json("data/forcealgo.json", function (error, graph) {
        var vertices = [];
        var edges = [];
        var verticesB = [];
        var edgesB = [];
        var svg = d3.select("#algo-sparse-svgA");
        var svgB = d3.select("#algo-sparse-svgB");
        var width = 500, height = 500;
        initGraph(graph, vertices, edges, width, height);
        initGraph(graph, verticesB, edgesB, width, height);
        /*var adjList = getAdjList(vertices, edges);
        var adjMatrix = getAdjMatrix(vertices, edges);*/
        basicLayout(svg, vertices, edges);
        basicLayout(svgB, verticesB, edgesB);


        var simulation;
        var simulationB;
        var fixedpaths = [];


        function ticked() {
            svg.select("#nodes").selectAll(".node")
                .attr("transform", function(d) {
                    return "translate(" + d.x + "," + d.y + ")"; });
            svg.select("#links").selectAll(".link")
                .attr("x1", function(d) { return d.s.x; })
                .attr("y1", function(d) { return d.s.y; })
                .attr("x2", function(d) { return d.t.x; })
                .attr("y2", function(d) { return d.t.y; });
        }
        function tickedB() {
            fixedpaths.forEach(function(fp) {
                var basex = fp[0].x;
                var basey = fp[0].y;
                var steps = fp.length-1;
                var tarx = fp[steps].x;
                var tary = fp[steps].y;
                var stepx = (tarx - basex) / steps;
                var stepy = (tary - basey) / steps;
                for (var i = 1; i < steps; i++) {
                    fp[i].x = basex + i * stepx;
                    fp[i].y = basey + i * stepy;
                }
            });
            svgB.select("#nodes").selectAll(".node")
                .attr("transform", function(d) {
                    return "translate(" + d.x + "," + d.y + ")"; });
            svgB.select("#nodesHighlighted").selectAll("circle")
                .attr("transform", function(d) {
                    return "translate(" + d.x + "," + d.y + ")"; });
            svgB.select("#links").selectAll(".link")
                .attr("x1", function(d) { return d.s.x; })
                .attr("y1", function(d) { return d.s.y; })
                .attr("x2", function(d) { return d.t.x; })
                .attr("y2", function(d) { return d.t.y; });
            svgB.select("#linksHighlighted").selectAll("line")
                .attr("x1", function(d) { return d.s.x; })
                .attr("y1", function(d) { return d.s.y; })
                .attr("x2", function(d) { return d.t.x; })
                .attr("y2", function(d) { return d.t.y; });
        }

        var edgesToFix = [[edgesB[4], edgesB[6], edgesB[7], edgesB[20], edgesB[21]],
            [edgesB[13], edgesB[12], edgesB[0], edgesB[11]],
            [edgesB[2], edgesB[9], edgesB[17], edgesB[18]],
            [edgesB[8], edgesB[19]],
            [edgesB[23], edgesB[22]],
            [edgesB[16], edgesB[15], edgesB[3]]];
        var pathsToFix = [[verticesB[8], verticesB[7], verticesB[9], verticesB[10], verticesB[18], verticesB[19]],
            [verticesB[15], verticesB[14], verticesB[1], verticesB[0], verticesB[13]],
            [verticesB[10], verticesB[17], verticesB[12], verticesB[4], verticesB[3]],
            [verticesB[13], verticesB[11], verticesB[12]],
            [verticesB[10], verticesB[20], verticesB[5]],
            [verticesB[5], verticesB[6], verticesB[16], verticesB[8]]];

        Reveal.addEventListener( 'fragmentshown', function( event ) {
            var id = event.fragment.getAttribute('id');
            switch(id) {
                case 'algo-sparse-1':
                    simulation = d3.forceSimulation()
                        .force("link", d3.forceLink().id(function(d) { return d.id; }))
                        .force("charge", d3.forceManyBody().strength(-30))
                        .force("center", d3.forceCenter(width / 2, height / 2));
                    simulation
                        .nodes(vertices)
                        .on("tick", ticked);
                    simulation.force("link")
                        .links(edges);
                    break;
                case 'algo-sparse-2':
                    simulationB = d3.forceSimulation()
                        .force("link", d3.forceLink().id(function(d) { return d.id; }))
                        .force("charge", d3.forceManyBody().strength(-30))
                        .force("center", d3.forceCenter(width / 2, height / 2));
                    simulationB
                        .nodes(verticesB)
                        .on("tick", tickedB);
                    simulationB.force("link")
                        .links(edgesB);
                    svgB.classed("showhalo",false);
                    break;
                case 'algo-sparse-3':
                    edgesToFix[0].forEach(function(d) {highlightLink(svgB,d,0);});
                    pathsToFix[0].forEach(function(d) {highlightNode(svgB,d,0);});
                    break;
                case 'algo-sparse-4':
                    fixedpaths.push(pathsToFix[0]);
                    simulationB.stop();
                    verticesB.forEach(function (d) {
                        d.x = d.origx;
                        d.y = d.origy;
                    });
                    updateDrawing(svgB);
                    simulationB = d3.forceSimulation()
                        .force("link", d3.forceLink().id(function(d) { return d.id; }))
                        .force("charge", d3.forceManyBody().strength(-30))
                        .force("center", d3.forceCenter(width / 2, height / 2));
                    simulationB
                        .nodes(verticesB)
                        .on("tick", tickedB);
                    simulationB.force("link")
                        .links(edgesB);
                    break;
                case 'algo-sparse-5':
                    edgesToFix[1].forEach(function(d) {highlightLink(svgB,d,1);});
                    pathsToFix[1].forEach(function(d) {highlightNode(svgB,d,1);});
                    break;
                case 'algo-sparse-6':
                    fixedpaths.push(pathsToFix[1]);
                    simulationB.stop();
                    verticesB.forEach(function (d) {
                        d.x = d.origx;
                        d.y = d.origy;
                    });
                    updateDrawing(svgB);
                    simulationB = d3.forceSimulation()
                        .force("link", d3.forceLink().id(function(d) { return d.id; }))
                        .force("charge", d3.forceManyBody().strength(-30))
                        .force("center", d3.forceCenter(width / 2, height / 2));
                    simulationB
                        .nodes(verticesB)
                        .on("tick", tickedB);
                    simulationB.force("link")
                        .links(edgesB);
                    break;
                case 'algo-sparse-7':
                    edgesToFix[2].forEach(function(d) {highlightLink(svgB,d,2);});
                    pathsToFix[2].forEach(function(d) {highlightNode(svgB,d,2);});
                    break;
                case 'algo-sparse-8':
                    fixedpaths.push(pathsToFix[2]);
                    simulationB.stop();
                    verticesB.forEach(function (d) {
                        d.x = d.origx;
                        d.y = d.origy;
                    });
                    updateDrawing(svgB);
                    simulationB = d3.forceSimulation()
                        .force("link", d3.forceLink().id(function(d) { return d.id; }))
                        .force("charge", d3.forceManyBody().strength(-30))
                        .force("center", d3.forceCenter(width / 2, height / 2));
                    simulationB
                        .nodes(verticesB)
                        .on("tick", tickedB);
                    simulationB.force("link")
                        .links(edgesB);
                    break;
                case 'algo-sparse-9':
                    edgesToFix[3].forEach(function(d) {highlightLink(svgB,d,3);});
                    pathsToFix[3].forEach(function(d) {highlightNode(svgB,d,3);});
                    edgesToFix[4].forEach(function(d) {highlightLink(svgB,d,4);});
                    pathsToFix[4].forEach(function(d) {highlightNode(svgB,d,4);});
                    edgesToFix[5].forEach(function(d) {highlightLink(svgB,d,5);});
                    pathsToFix[5].forEach(function(d) {highlightNode(svgB,d,5);});
                    break;
                case 'algo-sparse-10':
                    fixedpaths.push(pathsToFix[3]);
                    fixedpaths.push(pathsToFix[4]);
                    fixedpaths.push(pathsToFix[5]);
                    simulationB.stop();
                    verticesB.forEach(function (d) {
                        d.x = d.origx;
                        d.y = d.origy;
                    });
                    updateDrawing(svgB);
                    simulationB = d3.forceSimulation()
                        .force("link", d3.forceLink().id(function(d) { return d.id; }))
                        .force("charge", d3.forceManyBody().strength(-30))
                        .force("center", d3.forceCenter(width / 2, height / 2));
                    simulationB
                        .nodes(verticesB)
                        .on("tick", tickedB);
                    simulationB.force("link")
                        .links(edgesB);
                    break;
                case 'algo-sparse-11':
                    clearHighlights(svgB,edgesB);
                    break;
            }
        } );

        Reveal.addEventListener( 'fragmenthidden', function( event ) {
            var id = event.fragment.getAttribute('id');
            switch(id) {
                case 'algo-sparse-1':
                    simulation.stop();
                    vertices.forEach(function (d) {
                        d.x = d.origx;
                        d.y = d.origy;
                    });
                    updateDrawing(svg);
                    break;
                case 'algo-sparse-2':
                    simulationB.stop();
                    verticesB.forEach(function (d) {
                        d.x = d.origx;
                        d.y = d.origy;
                    });
                    updateDrawing(svgB);
                    svgB.classed("showhalo",true);
                    break;
                case 'algo-sparse-3':
                    edgesToFix[0].forEach(function(d) {unhighlight(svgB,d);});
                    svgB.select("#nodesHighlighted")
                        .selectAll(".nodeHighlight0")
                        .remove();
                    break;
                case 'algo-sparse-4':
                    fixedpaths = [];
                    console.log(fixedpaths);
                    simulationB.stop();
                    verticesB.forEach(function (d) {
                        d.x = d.origx;
                        d.y = d.origy;
                    });
                    updateDrawing(svgB);
                    simulationB = d3.forceSimulation()
                        .force("link", d3.forceLink().id(function(d) { return d.id; }))
                        .force("charge", d3.forceManyBody().strength(-30))
                        .force("center", d3.forceCenter(width / 2, height / 2));
                    simulationB
                        .nodes(verticesB)
                        .on("tick", tickedB);
                    simulationB.force("link")
                        .links(edgesB);
                    break;
                case 'algo-sparse-5':
                    edgesToFix[1].forEach(function(d) {unhighlight(svgB,d);});
                    svgB.select("#nodesHighlighted")
                        .selectAll(".nodeHighlight"+1)
                        .remove();
                    break;
                case 'algo-sparse-6':
                    fixedpaths.splice(1,1);
                    simulationB.stop();
                    verticesB.forEach(function (d) {
                        d.x = d.origx;
                        d.y = d.origy;
                    });
                    updateDrawing(svgB);
                    simulationB = d3.forceSimulation()
                        .force("link", d3.forceLink().id(function(d) { return d.id; }))
                        .force("charge", d3.forceManyBody().strength(-30))
                        .force("center", d3.forceCenter(width / 2, height / 2));
                    simulationB
                        .nodes(verticesB)
                        .on("tick", tickedB);
                    simulationB.force("link")
                        .links(edgesB);
                    break;
                case 'algo-sparse-7':
                    edgesToFix[2].forEach(function(d) {unhighlight(svgB,d);});
                    svgB.select("#nodesHighlighted")
                        .selectAll(".nodeHighlight2")
                        .remove();
                    break;
                case 'algo-sparse-8':
                    fixedpaths.splice(1,2);
                    simulationB.stop();
                    verticesB.forEach(function (d) {
                        d.x = d.origx;
                        d.y = d.origy;
                    });
                    updateDrawing(svgB);
                    simulationB = d3.forceSimulation()
                        .force("link", d3.forceLink().id(function(d) { return d.id; }))
                        .force("charge", d3.forceManyBody().strength(-30))
                        .force("center", d3.forceCenter(width / 2, height / 2));
                    simulationB
                        .nodes(verticesB)
                        .on("tick", tickedB);
                    simulationB.force("link")
                        .links(edgesB);
                    break;
                case 'algo-sparse-9':
                    for (var i = 3; i < 6; i++) {
                        edgesToFix[i].forEach(function(d) {unhighlight(svgB,d);});
                        svgB.select("#nodesHighlighted")
                            .selectAll(".nodeHighlight"+i)
                            .remove();
                    }
                    break;
                case 'algo-sparse-10':
                    fixedpaths.splice(3,3);
                    simulationB.stop();
                    verticesB.forEach(function (d) {
                        d.x = d.origx;
                        d.y = d.origy;
                    });
                    updateDrawing(svgB);
                    simulationB = d3.forceSimulation()
                        .force("link", d3.forceLink().id(function(d) { return d.id; }))
                        .force("charge", d3.forceManyBody().strength(-30))
                        .force("center", d3.forceCenter(width / 2, height / 2));
                    simulationB
                        .nodes(verticesB)
                        .on("tick", tickedB);
                    simulationB.force("link")
                        .links(edgesB);
                    break;
                case 'algo-sparse-11':
                    for (var i = 0; i < 6; i++) {
                        edgesToFix[i].forEach(function(d) {highlightLink(svgB,d,i);});
                        pathsToFix[i].forEach(function(d) {highlightNode(svgB,d,i);});
                    }
                    break;
            }
        } );

    });

}

function treealgoA() {
    var vertices = [];
    var edges = [];
    var svg = d3.select("#algo-tree-svgA");
    var width = 350, height = 350;
    d3.json("data/treealgos-tidier.json", function (error, graph) {
        initGraph(graph, vertices, edges, width, height);

        var leaves = [vertices[5], vertices[6], vertices[7], vertices[11], vertices[9], vertices[3], vertices[14], vertices[1]];

        Reveal.addEventListener( 'fragmentshown', function( event ) {
            var id = event.fragment.getAttribute('id');
            switch(id) {
                case 'algo-treeA-1':
                    leaves.forEach(function(d) {
                        addNode(svg,d);
                    });
                    break;
                case 'algo-treeA-2':
                    addNode(svg,vertices[4]);
                    addEdge(svg,edges[6]);
                    addEdge(svg,edges[7]);
                    addEdge(svg,edges[8]);
                    break;
                case 'algo-treeA-3':
                    addNode(svg,vertices[10]);
                    addEdge(svg,edges[11]);
                    break;
                case 'algo-treeA-4':
                    addNode(svg,vertices[8]);
                    addEdge(svg,edges[9]);
                    addEdge(svg,edges[10]);
                    break;
                case 'algo-treeA-5':
                    vertices[9].y -= graph.scale * 2;
                    updateDrawing(svg);
                    break;
                case 'algo-treeA-6':
                    addNode(svg,vertices[2]);
                    addEdge(svg,edges[3]);
                    addEdge(svg,edges[4]);
                    addCurvedEdge(svg,edges[5]);
                    break;
                case 'algo-treeA-7':
                    vertices[4].y -= graph.scale * 2;
                    vertices[5].y -= graph.scale * 2;
                    vertices[6].y -= graph.scale * 2;
                    vertices[7].y -= graph.scale * 2;
                    vertices[3].x -= graph.scale;
                    vertices[3].y -= graph.scale * 4;
                    updateDrawing(svg);
                    break;
                case 'algo-treeA-8':
                    addNode(svg,vertices[13]);
                    addEdge(svg,edges[13]);
                    break;
                case 'algo-treeA-9':
                    addNode(svg,vertices[12]);
                    addEdge(svg,edges[12]);
                    break;
                case 'algo-treeA-10':
                    addNode(svg,vertices[0]);
                    addEdge(svg,edges[0]);
                    addEdge(svg,edges[1]);
                    addCurvedEdge(svg,edges[2]);
                    break;
                case 'algo-treeA-11':
                    vertices[12].x -= graph.scale;
                    vertices[12].y -= graph.scale * 2;
                    vertices[13].x -= graph.scale;
                    vertices[13].y -= graph.scale * 2;
                    vertices[14].x -= graph.scale;
                    vertices[14].y -= graph.scale * 2;
                    vertices[1].x -= graph.scale;
                    vertices[1].y -= graph.scale * 6;
                    updateDrawing(svg);
                    break;
            }
        } );

        Reveal.addEventListener( 'fragmenthidden', function( event ) {
            var id = event.fragment.getAttribute('id');
            switch(id) {
                case 'algo-treeA-1':
                    leaves.forEach(function(d) {
                        removeNode(svg,d);
                    });
                    break;
                case 'algo-treeA-2':
                    removeNode(svg,vertices[4]);
                    removeEdge(svg,edges[6]);
                    removeEdge(svg,edges[7]);
                    removeEdge(svg,edges[8]);
                    break;
                case 'algo-treeA-3':
                    removeNode(svg,vertices[10]);
                    removeEdge(svg,edges[11]);
                    break;
                case 'algo-treeA-4':
                    removeNode(svg,vertices[8]);
                    removeEdge(svg,edges[9]);
                    removeEdge(svg,edges[10]);
                    break;
                case 'algo-treeA-5':
                    vertices[9].y += graph.scale * 2;
                    updateDrawing(svg);
                    break;
                case 'algo-treeA-6':
                    removeNode(svg,vertices[2]);
                    removeEdge(svg,edges[3]);
                    removeEdge(svg,edges[4]);
                    removeCurvedEdge(svg,edges[5]);
                    break;
                case 'algo-treeA-7':
                    vertices[4].y += graph.scale * 2;
                    vertices[5].y += graph.scale * 2;
                    vertices[6].y += graph.scale * 2;
                    vertices[7].y += graph.scale * 2;
                    vertices[3].x += graph.scale;
                    vertices[3].y += graph.scale * 4;
                    updateDrawing(svg);
                    curve(svg,edges[5]);
                    break;
                case 'algo-treeA-8':
                    removeNode(svg,vertices[13]);
                    removeEdge(svg,edges[13]);
                    break;
                case 'algo-treeA-9':
                    removeNode(svg,vertices[12]);
                    removeEdge(svg,edges[12]);
                    break;
                case 'algo-treeA-10':
                    removeNode(svg,vertices[0]);
                    removeEdge(svg,edges[0]);
                    removeEdge(svg,edges[1]);
                    removeCurvedEdge(svg,edges[2]);
                    break;
                case 'algo-treeA-11':
                    vertices[12].x += graph.scale;
                    vertices[12].y += graph.scale * 2;
                    vertices[13].x += graph.scale;
                    vertices[13].y += graph.scale * 2;
                    vertices[14].x += graph.scale;
                    vertices[14].y += graph.scale * 2;
                    vertices[1].x += graph.scale;
                    vertices[1].y += graph.scale * 6;
                    updateDrawing(svg);
                    curve(svg,edges[2]);
                    break;
            }
        } );

    });
}


function treealgoB() {
    var vertices = [];
    var edges = [];
    var svg = d3.select("#algo-tree-svgB");
    var width = 350, height = 350;
    d3.json("data/treealgos-quad-init.json", function (error, graph) {
        initGraph(graph, vertices, edges, width, height);

        var leaves = [vertices[14], vertices[11], vertices[9], vertices[7], vertices[6], vertices[5], vertices[3], vertices[1]];

        Reveal.addEventListener( 'fragmentshown', function( event ) {
            var id = event.fragment.getAttribute('id');
            switch(id) {
                case 'algo-treeB-1':
                    leaves.forEach(function(d) {
                        addNode(svg,d);
                    });
                    break;
                case 'algo-treeB-2':
                    addNode(svg,vertices[13]);
                    addEdge(svg,edges[13]);
                    break;
                case 'algo-treeB-3':
                    addNode(svg,vertices[12]);
                    addEdge(svg,edges[12]);
                    break;
                case 'algo-treeB-4':
                    addNode(svg,vertices[10]);
                    addEdge(svg,edges[11]);
                    break;
                case 'algo-treeB-5':
                    addNode(svg,vertices[8]);
                    addEdge(svg,edges[10]);
                    addEdge(svg,edges[9]);
                    break;
                case 'algo-treeB-6':
                    vertices[9].x -= graph.scale;
                    updateDrawing(svg);
                    break;
                case 'algo-treeB-7':
                    addNode(svg,vertices[4]);
                    addEdge(svg,edges[8]);
                    addEdge(svg,edges[7]);
                    addEdge(svg,edges[6]);
                    break;
                case 'algo-treeB-8':
                    vertices[7].x -= graph.scale;
                    vertices[6].y += graph.scale;
                    vertices[5].y += graph.scale;
                    updateDrawing(svg);
                    break;
                case 'algo-treeB-9':
                    addNode(svg,vertices[2]);
                    addEdge(svg,edges[5]);
                    addEdge(svg,edges[4]);
                    addEdge(svg,edges[3]);
                    break;
                case 'algo-treeB-10':
                    vertices[8].x -= graph.scale * 1;
                    vertices[8].y -= graph.scale * 2;
                    vertices[9].x -= graph.scale * 2;
                    vertices[9].y -= graph.scale * 1;
                    vertices[10].x -= graph.scale * 3;
                    vertices[10].y -= graph.scale * 2;
                    vertices[11].x -= graph.scale * 4;
                    vertices[11].y -= graph.scale * 1;
                    vertices[3].x -= graph.scale * 1;
                    vertices[3].y += graph.scale * 1;
                    updateDrawing(svg);
                    break;
                case 'algo-treeB-11':
                    addNode(svg,vertices[0]);
                    addCurvedEdge(svg,edges[0],true);
                    addCurvedEdge(svg,edges[1],true);
                    addCurvedEdge(svg,edges[2],true);
                    break;
                case 'algo-treeB-12':
                    vertices[1].x -= graph.scale * 6;
                    vertices[1].y += graph.scale * 4;
                    vertices[2].x -= graph.scale * 1;
                    vertices[3].x -= graph.scale * 2;
                    vertices[3].y -= graph.scale * 1;
                    vertices[4].x -= graph.scale * 1;
                    vertices[4].y -= graph.scale * 2;
                    vertices[5].x -= graph.scale * 2;
                    vertices[5].y -= graph.scale * 3;
                    vertices[6].x -= graph.scale * 1;
                    vertices[6].y -= graph.scale * 4;
                    vertices[7].y -= graph.scale * 3;
                    vertices[8].x += graph.scale * 1;
                    vertices[9].x += graph.scale * 2;
                    vertices[9].y -= graph.scale * 1;
                    vertices[10].x += graph.scale * 3;
                    vertices[11].x += graph.scale * 4;
                    vertices[11].y -= graph.scale * 1;
                    vertices[12].x -= graph.scale * 3;
                    vertices[12].y -= graph.scale * 1;
                    vertices[13].x -= graph.scale * 3;
                    vertices[13].y -= graph.scale * 1;
                    vertices[14].x -= graph.scale * 3;
                    vertices[14].y -= graph.scale * 1;
                    updateDrawing(svg);
                    break;
            }
        } );

        Reveal.addEventListener( 'fragmenthidden', function( event ) {
            var id = event.fragment.getAttribute('id');
            switch(id) {
                case 'algo-treeB-1':
                    leaves.forEach(function(d) {
                        removeNode(svg,d);
                    });
                    break;
                case 'algo-treeB-2':
                    removeNode(svg,vertices[13]);
                    removeEdge(svg,edges[13]);
                    break;
                case 'algo-treeB-3':
                    removeNode(svg,vertices[12]);
                    removeEdge(svg,edges[12]);
                    break;
                case 'algo-treeB-4':
                    removeNode(svg,vertices[10]);
                    removeEdge(svg,edges[11]);
                    break;
                case 'algo-treeB-5':
                    removeNode(svg,vertices[8]);
                    removeEdge(svg,edges[10]);
                    removeEdge(svg,edges[9]);
                    break;
                case 'algo-treeB-6':
                    vertices[9].x += graph.scale;
                    updateDrawing(svg);
                    break;
                case 'algo-treeB-7':
                    removeNode(svg,vertices[4]);
                    removeEdge(svg,edges[8]);
                    removeEdge(svg,edges[7]);
                    removeEdge(svg,edges[6]);
                    break;
                case 'algo-treeB-8':
                    vertices[7].x += graph.scale;
                    vertices[6].y -= graph.scale;
                    vertices[5].y -= graph.scale;
                    updateDrawing(svg);
                    break;
                case 'algo-treeB-9':
                    removeNode(svg,vertices[2]);
                    removeEdge(svg,edges[5]);
                    removeEdge(svg,edges[4]);
                    removeEdge(svg,edges[3]);
                    break;
                case 'algo-treeB-10':
                    vertices[8].x += graph.scale * 1;
                    vertices[8].y += graph.scale * 2;
                    vertices[9].x += graph.scale * 2;
                    vertices[9].y += graph.scale * 1;
                    vertices[10].x += graph.scale * 3;
                    vertices[10].y += graph.scale * 2;
                    vertices[11].x += graph.scale * 4;
                    vertices[11].y += graph.scale * 1;
                    vertices[3].x += graph.scale * 1;
                    vertices[3].y -= graph.scale * 1;
                    updateDrawing(svg);
                    break;
                case 'algo-treeB-11':
                    removeNode(svg,vertices[0]);
                    removeCurvedEdge(svg,edges[0],true);
                    removeCurvedEdge(svg,edges[1],true);
                    removeCurvedEdge(svg,edges[2],true);
                    break;
                case 'algo-treeB-12':
                    vertices[1].x += graph.scale * 6;
                    vertices[1].y -= graph.scale * 4;
                    vertices[2].x += graph.scale * 1;
                    vertices[3].x += graph.scale * 2;
                    vertices[3].y += graph.scale * 1;
                    vertices[4].x += graph.scale * 1;
                    vertices[4].y += graph.scale * 2;
                    vertices[5].x += graph.scale * 2;
                    vertices[5].y += graph.scale * 3;
                    vertices[6].x += graph.scale * 1;
                    vertices[6].y += graph.scale * 4;
                    vertices[7].y += graph.scale * 3;
                    vertices[8].x -= graph.scale * 1;
                    vertices[9].x -= graph.scale * 2;
                    vertices[9].y += graph.scale * 1;
                    vertices[10].x -= graph.scale * 3;
                    vertices[11].x -= graph.scale * 4;
                    vertices[11].y += graph.scale * 1;
                    vertices[12].x += graph.scale * 3;
                    vertices[12].y += graph.scale * 1;
                    vertices[13].x += graph.scale * 3;
                    vertices[13].y += graph.scale * 1;
                    vertices[14].x += graph.scale * 3;
                    vertices[14].y += graph.scale * 1;
                    updateDrawing(svg);
                    curve(svg,edges[0],true);
                    curve(svg,edges[1],true);
                    curve(svg,edges[2],true);
                    break;
            }
        } );

    });
}

function treealgoC() {
    var vertices = [];
    var verticesA = [];
    var verticesB = [];
    var edges = [];
    var edgesA = [];
    var edgesB = [];
    var svgA = d3.select("#algo-tree-svgA");
    var svgB = d3.select("#algo-tree-svgB");
    var svg = d3.select("#algo-tree-svgC");
    var width = 350, height = 350;
    d3.json("data/treealgos-fsbase.json", function (error, graph) {
        d3.json("data/treealgos-fstilt.json", function (errorA, graphA) {
            d3.json("data/treealgos-fspost.json", function (errorB, graphB) {
                initGraph(graph, vertices, edges, width, height);
                initGraph(graphA, verticesA, edgesA, width, height);
                initGraph(graphB, verticesB, edgesB, width, height);

                var heavypaths = [
                    [vertices[0], vertices[2], vertices[4], vertices[5]],
                    [vertices[8], vertices[10], vertices[11]],
                    [vertices[12], vertices[13], vertices[14]]
                ];
                var heavyedges = [
                    [edges[0], edges[3], edges[6]],
                    [edges[9], edges[11]],
                    [edges[12], edges[13]]
                ];

                Reveal.addEventListener('fragmentshown', function (event) {
                    var id = event.fragment.getAttribute('id');
                    switch (id) {
                        case 'algo-treeC-1':
                            highlightHeavyNode(heavypaths[0][0],0);
                            break;
                        case 'algo-treeC-2':
                            highlightHeavyNode(heavypaths[0][1],0);
                            highlightHeavyEdge(heavyedges[0][0],0);
                            break;
                        case 'algo-treeC-3':
                            highlightHeavyNode(heavypaths[0][2],0);
                            highlightHeavyEdge(heavyedges[0][1],0);
                            break;
                        case 'algo-treeC-4':
                            highlightHeavyNode(heavypaths[0][3],0);
                            highlightHeavyEdge(heavyedges[0][2],0);
                            break;
                        case 'algo-treeC-5':
                            highlightHeavyPath(1);
                            break;
                        case 'algo-treeC-6':
                            highlightHeavyPath(2);
                            break;
                        case 'algo-treeC-7':
                            heavypaths[2].forEach(function(d,i) {
                                d.x += graph.scale;
                                d.y += graph.scale * 3;
                                addNode(svg, d);
                                highlightNode(svg,d,2);
                            });
                            heavyedges[2].forEach(function(d) {
                                addEdge(svg,d);
                                highlightLink(svg,d,2);
                            });
                            break;
                        case 'algo-treeC-8':
                            heavypaths[2].forEach(function(d,i) {
                                d.x += graph.scale * 6;
                                d.y += graph.scale * 5;
                            });
                            updateDrawing(svg);
                            break;
                        case 'algo-treeC-9':
                            heavypaths[1][0].x += graph.scale * 2;
                            addNode(svg,heavypaths[1][0]);
                            highlightNode(svg,heavypaths[1][0],1);
                            break;
                        case 'algo-treeC-10':
                            addNode(svg,vertices[9]);
                            addEdge(svg,edges[10]);
                            break;
                        case 'algo-treeC-11':
                            heavypaths[1][1].x += graph.scale * 2;
                            addNode(svg,heavypaths[1][1]);
                            addEdge(svg,heavyedges[1][0]);
                            highlightNode(svg,heavypaths[1][1],1);
                            highlightLink(svg,heavyedges[1][0],1);
                            break;
                        case 'algo-treeC-12':
                            heavypaths[1][2].x += graph.scale * 2;
                            addNode(svg,heavypaths[1][2]);
                            addEdge(svg,heavyedges[1][1]);
                            highlightNode(svg,heavypaths[1][2],1);
                            highlightLink(svg,heavyedges[1][1],1);
                            break;
                        case 'algo-treeC-13':
                            heavypaths[1].forEach(function(d) {
                               d.x -= graph.scale * 5;
                               d.y += graph.scale * 3;
                            });
                            vertices[9].x -= graph.scale * 5;
                            vertices[9].y += graph.scale * 3;
                            updateDrawing(svg);
                            break;
                        case 'algo-treeC-14':
                            addNode(svg,heavypaths[0][0]);
                            highlightNode(svg,heavypaths[0][0],0);
                            break;
                        case 'algo-treeC-15':
                            addNode(svg,vertices[1]);
                            addEdge(svg,edges[2]);
                            addEdge(svg,edges[1]);
                            break;
                        case 'algo-treeC-16':
                            heavypaths[2].forEach(function(d,i) {
                                d.x -= graph.scale * 7;
                                d.y -= graph.scale * 8;
                            });
                            updateDrawing(svg);
                            break;
                        case 'algo-treeC-17':
                            addNode(svg,heavypaths[0][1]);
                            addEdge(svg,heavyedges[0][0]);
                            highlightNode(svg,heavypaths[0][1],0);
                            highlightLink(svg,heavyedges[0][0],0);
                            break;
                        case 'algo-treeC-18':
                            addNode(svg,vertices[3]);
                            addEdge(svg,edges[5]);
                            addEdge(svg,edges[4]);
                            break;
                        case 'algo-treeC-19':
                            heavypaths[1].forEach(function(d,i) {
                                d.x += graph.scale * 3;
                                d.y -= graph.scale * 3;
                            });
                            vertices[9].x += graph.scale * 5;
                            vertices[9].y -= graph.scale * 3;
                            updateDrawing(svg);
                            break;
                        case 'algo-treeC-20':
                            addNode(svg,heavypaths[0][2]);
                            addEdge(svg,heavyedges[0][1]);
                            highlightNode(svg,heavypaths[0][2],0);
                            highlightLink(svg,heavyedges[0][1],0);
                            break;
                        case 'algo-treeC-21':
                            addNode(svg,vertices[6]);
                            addNode(svg,vertices[7]);
                            addEdge(svg,edges[7]);
                            addEdge(svg,edges[8]);
                            break;
                        case 'algo-treeC-22':
                            addNode(svg,heavypaths[0][3]);
                            addEdge(svg,heavyedges[0][2]);
                            highlightNode(svg,heavypaths[0][3],0);
                            highlightLink(svg,heavyedges[0][2],0);
                            break;
                        case 'algo-treeC-23':
                            highlightNode(svg,vertices[3],1);
                            highlightLink(svg,edges[4],1);
                            highlightLink(svg,edges[5],1);
                            highlightNode(svg,vertices[1],2);
                            highlightLink(svg,edges[1],2);
                            highlightLink(svg,edges[2],2);
                            break;
                        case 'algo-treeC-24':
                            vertices.forEach(function(d) {
                                d.savex = d.x;
                                d.savey = d.y;
                                d.x = graphA.xtrans + graphA.scale * graphA.nodes[d.id].x;
                                d.y = graphA.ytrans + graphA.scale * graphA.nodes[d.id].y;
                            });
                            updateDrawing(svg);
                            break;
                        case 'algo-treeC-25':
                            clearHighlights(svg,edges);
                            clearHighlights(svgA,[]);
                            clearHighlights(svgB,[]);
                            break;
                        case 'algo-treeC-26':
                            vertices.forEach(function(d) {
                                d.x = graphB.xtrans + graphB.scale * graphB.nodes[d.id].x;
                                d.y = graphB.ytrans + graphB.scale * graphB.nodes[d.id].y;
                            });
                            updateDrawing(svg);
                            break;
                    }
                });

                Reveal.addEventListener('fragmenthidden', function (event) {
                    var id = event.fragment.getAttribute('id');
                    switch (id) {
                        case 'algo-treeC-1':
                            unhighlightHeavyNode(heavypaths[0][0],0);
                            break;
                        case 'algo-treeC-2':
                            unhighlightHeavyNode(heavypaths[0][1],0);
                            unhighlightHeavyEdge(heavyedges[0][0],0);
                            break;
                        case 'algo-treeC-3':
                            unhighlightHeavyNode(heavypaths[0][2],0);
                            unhighlightHeavyEdge(heavyedges[0][1],0);
                            break;
                        case 'algo-treeC-4':
                            unhighlightHeavyNode(heavypaths[0][3],0);
                            unhighlightHeavyEdge(heavyedges[0][2],0);
                            break;
                        case 'algo-treeC-5':
                            unhighlightHeavyPath(1);
                            break;
                        case 'algo-treeC-6':
                            unhighlightHeavyPath(2);
                            break;
                        case 'algo-treeC-7':
                            heavypaths[2].forEach(function(d,i) {
                                removeNode(svg, d);
                                unhighlightNode(svg,d,2);
                            });
                            heavyedges[2].forEach(function(d) {
                                removeEdge(svg,d);
                                unhighlightLink(svg,d,2);
                            });
                            break;
                        case 'algo-treeC-8':
                            heavypaths[2].forEach(function(d,i) {
                                d.x -= graph.scale * 6;
                                d.y -= graph.scale * 5;
                            });
                            updateDrawing(svg);
                            break;
                        case 'algo-treeC-9':
                            heavypaths[1][0].x += graph.scale * 2;
                            removeNode(svg,heavypaths[1][0]);
                            unhighlightNode(svg,heavypaths[1][0],1);
                            break;
                        case 'algo-treeC-10':
                            removeNode(svg,vertices[9]);
                            removeEdge(svg,edges[10]);
                            break;
                        case 'algo-treeC-11':
                            heavypaths[1][1].x += graph.scale * 2;
                            removeNode(svg,heavypaths[1][1]);
                            removeEdge(svg,heavyedges[1][0]);
                            unhighlightNode(svg,heavypaths[1][1],1);
                            unhighlightLink(svg,heavyedges[1][0],1);
                            break;
                        case 'algo-treeC-12':
                            heavypaths[1][2].x += graph.scale * 2;
                            removeNode(svg,heavypaths[1][2]);
                            removeEdge(svg,heavyedges[1][1]);
                            unhighlightNode(svg,heavypaths[1][2],1);
                            unhighlightLink(svg,heavyedges[1][1],1);
                            break;
                        case 'algo-treeC-13':
                            heavypaths[1].forEach(function(d) {
                                d.x += graph.scale * 5;
                                d.y -= graph.scale * 3;
                            });
                            vertices[9].x += graph.scale * 5;
                            vertices[9].y -= graph.scale * 3;
                            updateDrawing(svg);
                            break;
                        case 'algo-treeC-14':
                            removeNode(svg,heavypaths[0][0]);
                            unhighlightNode(svg,heavypaths[0][0],0);
                            break;
                        case 'algo-treeC-15':
                            removeNode(svg,vertices[1]);
                            removeEdge(svg,edges[2]);
                            removeEdge(svg,edges[1]);
                            break;
                        case 'algo-treeC-16':
                            heavypaths[2].forEach(function(d,i) {
                                d.x += graph.scale * 7;
                                d.y += graph.scale * 8;
                            });
                            updateDrawing(svg);
                            break;
                        case 'algo-treeC-17':
                            removeNode(svg,heavypaths[0][1]);
                            removeEdge(svg,heavyedges[0][0]);
                            unhighlightNode(svg,heavypaths[0][1],0);
                            unhighlightLink(svg,heavyedges[0][0],0);
                            break;
                        case 'algo-treeC-18':
                            removeNode(svg,vertices[3]);
                            removeEdge(svg,edges[5]);
                            removeEdge(svg,edges[4]);
                            break;
                        case 'algo-treeC-19':
                            heavypaths[1].forEach(function(d,i) {
                                d.x -= graph.scale * 3;
                                d.y += graph.scale * 3;
                            });
                            vertices[9].x -= graph.scale * 5;
                            vertices[9].y += graph.scale * 3;
                            updateDrawing(svg);
                            break;
                        case 'algo-treeC-20':
                            removeNode(svg,heavypaths[0][2]);
                            removeEdge(svg,heavyedges[0][1]);
                            unhighlightNode(svg,heavypaths[0][2],0);
                            unhighlightLink(svg,heavyedges[0][1],0);
                            break;
                        case 'algo-treeC-21':
                            removeNode(svg,vertices[6]);
                            removeNode(svg,vertices[7]);
                            removeEdge(svg,edges[7]);
                            removeEdge(svg,edges[8]);
                            break;
                        case 'algo-treeC-22':
                            removeNode(svg,heavypaths[0][3]);
                            removeEdge(svg,heavyedges[0][2]);
                            unhighlightNode(svg,heavypaths[0][3],0);
                            unhighlightLink(svg,heavyedges[0][2],0);
                            break;
                        case 'algo-treeC-23':
                            unhighlightNode(svg,vertices[3],1);
                            unhighlightLink(svg,edges[4],1);
                            unhighlightLink(svg,edges[5],1);
                            unhighlightNode(svg,vertices[1],2);
                            unhighlightLink(svg,edges[1],2);
                            unhighlightLink(svg,edges[2],2);
                            break;
                        case 'algo-treeC-24':
                            vertices.forEach(function(d) {
                                d.x = d.savex;
                                d.y = d.savey;
                            });
                            updateDrawing(svg);
                            break;
                        case 'algo-treeC-25':
                            highlightHeavyPath(0);
                            highlightHeavyPath(1);
                            highlightHeavyPath(2);
                            heavypaths.forEach(function(d,i) {
                                d.forEach(function(e) {
                                    highlightNode(svg,e,i);
                                });
                            });
                            heavyedges.forEach(function(d,i) {
                                d.forEach(function(e) {
                                    highlightLink(svg,e,i);
                                });
                            });
                            highlightNode(svg,vertices[3],1);
                            highlightLink(svg,edges[4],1);
                            highlightLink(svg,edges[5],1);
                            highlightNode(svg,vertices[1],2);
                            highlightLink(svg,edges[1],2);
                            highlightLink(svg,edges[2],2);
                            break;
                        case 'algo-treeC-26':
                            vertices.forEach(function(d) {
                                d.x = graphA.xtrans + graphA.scale * graphA.nodes[d.id].x;
                                d.y = graphA.ytrans + graphA.scale * graphA.nodes[d.id].y;
                            });
                            updateDrawing(svg);
                            break;
                    }
                });

                function highlightHeavyPath(id) {
                    heavypaths[id].forEach( function(d) {
                        highlightHeavyNode(d,id);
                    });
                    heavyedges[id].forEach( function(d) {
                        highlightHeavyEdge(d, id);
                    });
                }

                function unhighlightHeavyPath(id) {
                    heavypaths[id].forEach( function(d) {
                        unhighlightHeavyNode(d,id);
                    });
                    heavyedges[id].forEach( function(d) {
                        unhighlightHeavyEdge(d, id);
                    });
                }

                function highlightHeavyNode(d,id) {
                    var posA = svgA.select("#nodes")
                        .select("#n"+d.id)
                        .node()
                        .getAttribute("transform");
                    svgA.select("#nodesHighlighted")
                        .append("circle")
                        .attr("class", "nodeHighlight" + id)
                        .attr("id", "nh" + d.id)
                        .attr("transform", function() {
                            return posA;
                        })
                        .attr("r", 0)
                        .transition()
                        .attr("r", selectSize);
                    var posB = svgB.select("#nodes")
                        .select("#n"+d.id)
                        .node()
                        .getAttribute("transform");
                    svgB.select("#nodesHighlighted")
                        .append("circle")
                        .attr("class", "nodeHighlight" + id)
                        .attr("id", "nh" + d.id)
                        .attr("transform", function() {
                            return posB;
                        })
                        .attr("r", 0)
                        .transition()
                        .attr("r", selectSize);
                }

                function unhighlightHeavyNode(d,id) {
                    svgA.select("#nodesHighlighted")
                        .select("#nh"+d.id)
                        .transition()
                        .attr("r", 0)
                        .remove();
                    svgB.select("#nodesHighlighted")
                        .select("#nh"+d.id)
                        .transition()
                        .attr("r", 0)
                        .remove();
                }

                function highlightHeavyEdge(d,id) {
                    var posA = svgA.select("#links")
                        .select("#"+d.id)
                        .node();
                    svgA.select("#linksHighlighted")
                        .append("line")
                        .attr("class", "linkHighlight" + id)
                        .attr("id", "lh" + d.id)
                        .attr("x1", function() {
                            return posA.getAttribute("x1");
                        })
                        .attr("y1", function() {
                            return posA.getAttribute("y1");
                        })
                        .attr("x2", function() {
                            return posA.getAttribute("x1");
                        })
                        .attr("y2", function() {
                            return posA.getAttribute("y1");
                        })
                        .transition()
                        .attr("x2", function() {
                            return posA.getAttribute("x2");
                        })
                        .attr("y2", function() {
                            return posA.getAttribute("y2");
                        });
                    var posB = svgB.select("#links")
                        .select("#"+d.id)
                        .node();
                    svgB.select("#linksHighlighted")
                        .append("line")
                        .attr("class", "linkHighlight" + id)
                        .attr("id", "lh" + d.id)
                        .attr("x1", function() {
                            return posB.getAttribute("x1");
                        })
                        .attr("y1", function() {
                            return posB.getAttribute("y1");
                        })
                        .attr("x2", function() {
                            return posB.getAttribute("x1");
                        })
                        .attr("y2", function() {
                            return posB.getAttribute("y1");
                        })
                        .transition()
                        .attr("x2", function() {
                            return posB.getAttribute("x2");
                        })
                        .attr("y2", function() {
                            return posB.getAttribute("y2");
                        });
                }

                function unhighlightHeavyEdge(d,id) {
                    svgA.select("#linksHighlighted")
                        .select("#lh"+d.id)
                        .transition()
                        .attr("x2", function() {
                            return this.node().getAttribute("x1");
                        })
                        .attr("y2", function() {
                            return this.node().getAttribute("y1");
                        })
                        .remove();
                    svgB.select("#linksHighlighted")
                        .select("#lh" + d.id)
                        .transition()
                        .attr("x2", function() {
                            return this.node().getAttribute("x1");
                        })
                        .attr("y2", function() {
                            return this.node().getAttribute("y1");
                        })
                        .remove();
                }
            });
        });
    });
}



function hypothesesGraphs() {
    var width = 300, height = 300;
    var svgA = d3.select("#hypo-tree-svgA");
    var verticesA = [];
    var edgesA = [];
    d3.json("data/treealgos-tidier-final.json", function (errorA, graphA) {
        initGraph(graphA, verticesA, edgesA, width, height);
        basicLayout(svgA, verticesA, edgesA);
    });
    var svgB = d3.select("#hypo-tree-svgB");
    var verticesB = [];
    var edgesB = [];
    d3.json("data/treealgos-quad.json", function (errorB, graphB) {
        initGraph(graphB, verticesB, edgesB, width, height);
        basicLayout(svgB, verticesB, edgesB);
    });
    var svgC = d3.select("#hypo-tree-svgC");
    var verticesC = [];
    var edgesC = [];
    d3.json("data/treealgos-fspost.json", function (errorC, graphC) {
        initGraph(graphC, verticesC, edgesC, width, height);
        basicLayout(svgC, verticesC, edgesC);
    });
}



function conclusionGraphs() {
    var width = 300, height = 300;
    var svgA = d3.select("#concl-tree-svgA");
    var verticesA = [];
    var edgesA = [];
    d3.json("data/treealgos-tidier-final.json", function (errorA, graphA) {
        initGraph(graphA, verticesA, edgesA, width, height);
        basicLayout(svgA, verticesA, edgesA);
    });
    var svgB = d3.select("#concl-tree-svgB");
    var verticesB = [];
    var edgesB = [];
    d3.json("data/treealgos-quad.json", function (errorB, graphB) {
        initGraph(graphB, verticesB, edgesB, width, height);
        basicLayout(svgB, verticesB, edgesB);
    });
    var svgC = d3.select("#concl-tree-svgC");
    var verticesC = [];
    var edgesC = [];
    d3.json("data/treealgos-fspost.json", function (errorC, graphC) {
        initGraph(graphC, verticesC, edgesC, width, height);
        basicLayout(svgC, verticesC, edgesC);
    });
}



function aestheticsTask() {



    var width = 350,
        height = 350,
        seperation = 50 ;

    var graphdata = [];
    var adjList = [];
    var adjMatrix = [];

    var ranking = [0,0,0];
    var max_ranking = 0;

    var svgA = d3.select("#task-aesth-svgA")
        .on("click",function() {
            detectClick(0);
        });

    var svgB = d3.select("#task-aesth-svgB")
        .on("click",function() {
            detectClick(1);
        });

    var svgC = d3.select("#task-aesth-svgC")
        .on("click",function() {
            detectClick(2);
        });

    var rectA = svgA.append("rect")
        .attr("id","rectA")
        .attr("class","rank0")
        .attr("width", "100%")
        .attr("height", "100%");

    var ranknumberA = svgA.append("g")
        .attr("id","ranknumberA");

    var rectB = svgB.append("rect")
        .attr("id","rectB")
        .attr("class","rank0")
        .attr("width", "100%")
        .attr("height", "100%");

    var ranknumberB = svgB.append("g")
        .attr("id","ranknumberB");

    var rectC = svgC.append("rect")
        .attr("id","rectC")
        .attr("class","rank0")
        .attr("width", "100%")
        .attr("height", "100%");

    var ranknumberC = svgC.append("g")
        .attr("id","ranknumberC");

    var order = [0,1,2];
    var unshuffle = [0,1,2];
    var svg = [svgA, svgB, svgC];
    var rect = [rectA, rectB, rectC];
    var ranknumber = [ranknumberA, ranknumberB, ranknumberC];

    var vertices = [[],[],[]];
    var edges = [[],[],[]];


    // read data
    var jsondata = ["data/treealgos-tidier-final.json", "data/treealgos-quad.json", "data/treealgos-fspost.json"];
    var thisjsond = -1;
    for (var jsond = 0; jsond < jsondata.length; jsond++) {
        createGraph(jsond);
    }

    function detectClick(i) {
        [ranking[i],max_ranking] = detectAesthetic(svg[i],rect[i],ranknumber[i],ranking[i],max_ranking);
    }

    function createGraph(index) {

        d3.json(jsondata[order[index]], function(error, graph) {
            thisjsond = index;
            graphdata[thisjsond] = graph;
            JSON.parse(JSON.stringify(graph)); //Add this line
            initGraph(graph,vertices[thisjsond],edges[thisjsond],width,height);
            basicLayout(svg[thisjsond], vertices[thisjsond], edges[thisjsond]);

            startTime = new Date().getTime();
        });
    }
}





function pathFindingTask() {
    var width = 600,
        height = 600;

    var graphdata;
    var adjList = [];
    var adjMatrix = [];
    var path_complete = false;
    var path_start;
    var path_target;
    var vertices = [];
    var edges = [];
    var selected_path = [[],[]];
    var svg = d3.select("#task-path-svg");


    // read data
    d3.json("data/F3QA1B.json", function(error, graph) {
        graphdata=graph;
        initGraph(graph,vertices,edges,width,height);
        path_start = vertices[graph.markSource];
        path_target = vertices[graph.markTarget];
        adjList = getAdjList(vertices,edges);
        adjMatrix = getAdjMatrix(vertices, edges);
        basicLayout(svg, vertices, edges);
        highlightedLayout(svg, adjList, selected_path, path_start, path_target);
        svg.append("g").attr("id","clickevents");
        svg.select("#clickevents")
            .selectAll("circle")
            .data(vertices)
            .enter()
            .append("circle")
            .attr("r",20)
            .attr("transform",
                function(d) {
                return "translate("+d.x+","+d.y+")";
                })
            .style("opacity","0")
            .on("click",function(d) {
                if (d.highlighted || d.selected) {
                    toggleNode(graph, svg, vertices, edges, d, adjList, adjMatrix, selected_path, path_start, path_target);
                }
            });
    });
}




function furthestPairTask() {
    var width = 600,
        height = 600;

    var graphdata;
    var adjList = [];
    var adjMatrix = [];
    var graphFile = "data/introTreeQueryD.json";

    var svg = d3.select("#task-pair-svg");

    var vertices = [];
    var edges = [];


    // read data
    d3.json(graphFile, function (error, graph) {
        graphdata = graph;
        JSON.parse(JSON.stringify(graph)); //Add this line
        graph.markSource = -1;
        graph.markTarget = -1;
        initGraph(graph, vertices, edges,width,height);
        adjList = getAdjList(vertices, edges);
        adjMatrix = getAdjMatrix(vertices, edges);
        basicLayout(svg, vertices, edges);
        svg.append("g").attr("id","clickevents");
        svg.select("#clickevents")
            .selectAll("circle")
            .data(vertices)
            .enter()
            .append("circle")
            .attr("r",20)
            .attr("transform",
                function(d) {
                    return "translate("+d.x+","+d.y+")";
                })
            .style("opacity","0")
            .on("click",function(d) {
                handleNodeClick(graph,svg,vertices,edges,adjList,d);
            });
    });
}





function sectionStimuli() {
    var div = d3.select("#section-stimuli");


    Reveal.addEventListener( 'fragmentshown', function( event ) {
        var id = event.fragment.getAttribute('id');
        switch(id) {
            case 'section-stimuli-1':
                div.select("#td-path").classed("bg",true);
                div.select("#td-rep1").classed("bg",true);
                div.select("#td-stim1").classed("bg",true).text("2");
                break;
            case 'section-stimuli-2':
                div.select("#td-fd").classed("bg",true);
                div.select("#td-fdfs").classed("bg",true);
                div.select("#td-stim1").text("4");
                break;
            case 'section-stimuli-3':
                div.select("#td-rome").classed("bg",true);
                div.select("#td-rnd").classed("bg",true);
                div.select("#td-stim1").text("8");
                break;
            case 'section-stimuli-4':
                div.select("#td-size1").classed("bg",true);
                div.select("#td-size2").classed("bg",true);
                div.select("#td-stim1").text("16");
                break;
            case 'section-stimuli-5':
                div.select("#td-fd").classed("bg",false);
                div.select("#td-fdfs").classed("bg",false);
                div.select("#td-rome").classed("bg",false);
                div.select("#td-rnd").classed("bg",false);
                div.select("#td-size1").classed("bg",false);
                div.select("#td-size2").classed("bg",false);
                break;
            case 'section-stimuli-6':
                div.select("#td-faesth").classed("bg5",true);
                div.select("#td-rep2").classed("bg5",true);
                div.select("#td-stim2").classed("bg5",true).text("4");
                break;
            case 'section-stimuli-7':
                div.select("#td-fd").classed("bg5",true);
                div.select("#td-fdfs").classed("bg5",true);
                break;
            case 'section-stimuli-8':
                div.select("#td-rome").classed("bg5",true);
                div.select("#td-rnd").classed("bg5",true);
                div.select("#td-stim2").text("8");
                break;
            case 'section-stimuli-9':
                div.select("#td-size1").classed("bg5",true);
                div.select("#td-size2").classed("bg5",true);
                div.select("#td-stim2").text("16");
                break;
            case 'section-stimuli-10':
                div.select("#td-fd").classed("bg5",false);
                div.select("#td-fdfs").classed("bg5",false);
                div.select("#td-rome").classed("bg5",false);
                div.select("#td-rnd").classed("bg5",false);
                div.select("#td-size1").classed("bg5",false);
                div.select("#td-size2").classed("bg5",false);
                break;
            case 'section-stimuli-11':
                div.select("#td-pair").classed("bg1",true);
                div.select("#td-rep3").classed("bg1",true);
                div.select("#td-stim3").classed("bg1",true).text("2");
                break;
            case 'section-stimuli-12':
                div.select("#td-tidier").classed("bg1",true);
                div.select("#td-quad").classed("bg1",true);
                div.select("#td-fewseg").classed("bg1",true);
                div.select("#td-stim3").classed("bg1",true).text("6");
                break;
            case 'section-stimuli-13':
                div.select("#td-bal").classed("bg1",true);
                div.select("#td-deep").classed("bg1",true);
                div.select("#td-wide").classed("bg1",true);
                div.select("#td-stim3").text("18");
                break;
            case 'section-stimuli-14':
                div.select("#td-size3").classed("bg1",true);
                div.select("#td-size4").classed("bg1",true);
                div.select("#td-stim3").text("36");
                break;
            case 'section-stimuli-15':
                div.select("#td-tidier").classed("bg1",false);
                div.select("#td-quad").classed("bg1",false);
                div.select("#td-fewseg").classed("bg1",false);
                div.select("#td-bal").classed("bg1",false);
                div.select("#td-deep").classed("bg1",false);
                div.select("#td-wide").classed("bg1",false);
                div.select("#td-size3").classed("bg1",false);
                div.select("#td-size4").classed("bg1",false);
                break;
            case 'section-stimuli-16':
                div.select("#td-taesth").classed("bg3",true);
                div.select("#td-rep4").classed("bg3",true);
                div.select("#td-stim4").classed("bg3",true).text("4");
                break;
            case 'section-stimuli-17':
                div.select("#td-tidier").classed("bg3",true);
                div.select("#td-quad").classed("bg3",true);
                div.select("#td-fewseg").classed("bg3",true);
                break;
            case 'section-stimuli-18':
                div.select("#td-bal").classed("bg3",true);
                div.select("#td-deep").classed("bg3",true);
                div.select("#td-wide").classed("bg3",true);
                div.select("#td-stim4").text("12");
                break;
            case 'section-stimuli-19':
                div.select("#td-size3").classed("bg3",true);
                div.select("#td-size4").classed("bg3",true);
                div.select("#td-stim4").text("24");
                break;
            case 'section-stimuli-20':
                div.select("#td-tidier").classed("bg3",false);
                div.select("#td-quad").classed("bg3",false);
                div.select("#td-fewseg").classed("bg3",false);
                div.select("#td-bal").classed("bg3",false);
                div.select("#td-deep").classed("bg3",false);
                div.select("#td-wide").classed("bg3",false);
                div.select("#td-size3").classed("bg3",false);
                div.select("#td-size4").classed("bg3",false);
                break;
            case 'section-stimuli-21':
                div.select("#td-faesth").classed("bg5",false);
                div.select("#td-faesth").classed("bg",true);
                div.select("#td-rep2").classed("bg5",false);
                div.select("#td-rep2").classed("bg",true);
                div.select("#td-stim1").attr("colspan","6").text("32");
                div.select("#td-stim2").remove();
                break;
            case 'section-stimuli-22':
                div.select("#td-pair").classed("bg1",false);
                div.select("#td-rep3").classed("bg1",false);
                div.select("#td-size3").classed("bg1",true);
                div.select("#td-taesth").classed("bg3",false);
                div.select("#td-rep4").classed("bg3",false);
                div.select("#td-size4").classed("bg3",true);
                div.select("#td-stim3").text("30");
                div.select("#td-stim4").text("30");
        }
    } );


    Reveal.addEventListener( 'fragmenthidden', function( event ) {
        var id = event.fragment.getAttribute('id');
        switch(id) {
            case 'section-stimuli-1':
                div.select("#td-path").classed("bg",false);
                div.select("#td-rep1").classed("bg",false);
                div.select("#td-stim1").classed("bg",false).text("");
                break;
            case 'section-stimuli-2':
                div.select("#td-fd").classed("bg",false);
                div.select("#td-fdfs").classed("bg",false);
                div.select("#td-stim1").text("2");
                break;
            case 'section-stimuli-3':
                div.select("#td-rome").classed("bg",false);
                div.select("#td-rnd").classed("bg",false);
                div.select("#td-stim1").text("4");
                break;
            case 'section-stimuli-4':
                div.select("#td-size1").classed("bg",false);
                div.select("#td-size2").classed("bg",false);
                div.select("#td-stim1").text("8");
                break;
            case 'section-stimuli-5':
                div.select("#td-fd").classed("bg",true);
                div.select("#td-fdfs").classed("bg",true);
                div.select("#td-rome").classed("bg",true);
                div.select("#td-rnd").classed("bg",true);
                div.select("#td-size1").classed("bg",true);
                div.select("#td-size2").classed("bg",true);
                break;
            case 'section-stimuli-6':
                div.select("#td-faesth").classed("bg5",false);
                div.select("#td-rep2").classed("bg5",false);
                div.select("#td-stim2").classed("bg5",false).text("0");
                break;
            case 'section-stimuli-7':
                div.select("#td-fd").classed("bg5",false);
                div.select("#td-fdfs").classed("bg5",false);
                break;
            case 'section-stimuli-8':
                div.select("#td-rome").classed("bg5",false);
                div.select("#td-rnd").classed("bg5",false);
                div.select("#td-stim2").text("4");
                break;
            case 'section-stimuli-9':
                div.select("#td-size1").classed("bg5",false);
                div.select("#td-size2").classed("bg5",false);
                div.select("#td-stim2").text("8");
                break;
            case 'section-stimuli-10':
                div.select("#td-fd").classed("bg5",true);
                div.select("#td-fdfs").classed("bg5",true);
                div.select("#td-rome").classed("bg5",true);
                div.select("#td-rnd").classed("bg5",true);
                div.select("#td-size1").classed("bg5",true);
                div.select("#td-size2").classed("bg5",true);
                break;
            case 'section-stimuli-11':
                div.select("#td-pair").classed("bg1",false);
                div.select("#td-rep3").classed("bg1",false);
                div.select("#td-stim3").classed("bg1",false).text("");
                break;
            case 'section-stimuli-12':
                div.select("#td-tidier").classed("bg1",false);
                div.select("#td-quad").classed("bg1",false);
                div.select("#td-fewseg").classed("bg1",false);
                div.select("#td-stim3").classed("bg1",false).text("2");
                break;
            case 'section-stimuli-13':
                div.select("#td-bal").classed("bg1",false);
                div.select("#td-deep").classed("bg1",false);
                div.select("#td-wide").classed("bg1",false);
                div.select("#td-stim3").text("6");
                break;
            case 'section-stimuli-14':
                div.select("#td-size3").classed("bg1",false);
                div.select("#td-size4").classed("bg1",false);
                div.select("#td-stim3").text("18");
                break;
            case 'section-stimuli-15':
                div.select("#td-tidier").classed("bg1",true);
                div.select("#td-quad").classed("bg1",true);
                div.select("#td-fewseg").classed("bg1",true);
                div.select("#td-bal").classed("bg1",true);
                div.select("#td-deep").classed("bg1",true);
                div.select("#td-wide").classed("bg1",true);
                div.select("#td-size3").classed("bg1",true);
                div.select("#td-size4").classed("bg1",true);
                break;
            case 'section-stimuli-16':
                div.select("#td-taesth").classed("bg3",false);
                div.select("#td-rep4").classed("bg3",false);
                div.select("#td-stim4").classed("bg3",false).text("");
                break;
            case 'section-stimuli-17':
                div.select("#td-tidier").classed("bg3",false);
                div.select("#td-quad").classed("bg3",false);
                div.select("#td-fewseg").classed("bg3",false);
                break;
            case 'section-stimuli-18':
                div.select("#td-bal").classed("bg3",false);
                div.select("#td-deep").classed("bg3",false);
                div.select("#td-wide").classed("bg3",false);
                div.select("#td-stim4").text("4");
                break;
            case 'section-stimuli-19':
                div.select("#td-size3").classed("bg3",false);
                div.select("#td-size4").classed("bg3",false);
                div.select("#td-stim4").text("12");
                break;
            case 'section-stimuli-20':
                div.select("#td-tidier").classed("bg3",true);
                div.select("#td-quad").classed("bg3",true);
                div.select("#td-fewseg").classed("bg3",true);
                div.select("#td-bal").classed("bg3",true);
                div.select("#td-deep").classed("bg3",true);
                div.select("#td-wide").classed("bg3",true);
                div.select("#td-size3").classed("bg3",true);
                div.select("#td-size4").classed("bg3",true);
                break;
            case 'section-stimuli-21':
                div.select("#td-faesth").classed("bg5",true);
                div.select("#td-faesth").classed("bg",false);
                div.select("#td-rep2").classed("bg5",true);
                div.select("#td-rep2").classed("bg",false);
                div.select("#td-stim1").text("16");
                div.select("#td-stim2").classed("bg5",true).text("16");
                break;
            case 'section-stimuli-22':
                div.select("#td-pair").classed("bg1",true);
                div.select("#td-rep3").classed("bg1",true);
                div.select("#td-size3").classed("bg1",false);
                div.select("#td-taesth").classed("bg3",true);
                div.select("#td-rep4").classed("bg3",true);
                div.select("#td-size4").classed("bg3",false);
                div.select("#td-stim3").text("36");
                div.select("#td-stim4").text("24");
        }
    } );
}





function resultsHypothesis1() {
    var width = 40;
    var height = 440;
    var sep = 50;
    var section = d3.select("#section-results-hypo1");
    var svg = section.select("#results-hypo1-compchart");
    var svg_time = section.select("#results-hypo1-compchart-time");
    var container = section.select("#results-hypo1-cont");
    var container_time = section.select("#results-hypo1-cont-time");
    var textcontainer = container.append("g").attr("class","scaletext");
    var textcontainer_time = container_time.append("g").attr("class","scaletext");
    var pos = sep - width;


    Reveal.addEventListener( 'fragmentshown', function( event ) {
        var id = event.fragment.getAttribute('id');
        switch (id) {
            case "results-hypo1-1":
                pos = sep - width;
                container.append("g")
                    .attr("id","hypo1-all-fdfs")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("All")
                    .attr("id","hypo1-all-text")
                    .attr("x",pos)
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                container.append("g")
                    .attr("id","hypo1-all-fd")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo1-all-fdfs", "pathquery_all_fdfs.csv", width, height, .5, "results-hypo1-2", 0);
                barchart("hypo1-all-fd", "pathquery_all_fd.csv", width, height, .5, "results-hypo1-2", 1);
                break;
            case "results-hypo1-3":
                pos = 2.5 * sep + width;
                d3.select("#hypo1-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",700);
                d3.select("#hypo1-endline")
                    .transition()
                    .attr("x1",700)
                    .attr("x2",700);
                container.append("g")
                    .attr("id","hypo1-romes-fdfs")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("ROME small")
                    .attr("id","hypo1-romes-text")
                    .attr("x",pos)
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                textcontainer.append("text")
                    .text("p > 0.7")
                    .classed("disabled",true)
                    .attr("id","hypo1-romes-p")
                    .attr("x",pos+40)
                    .attr("y",height+80)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                container.append("g")
                    .attr("id","hypo1-romes-fd")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo1-romes-fdfs", "pathquery_romes_fdfs.csv", width, height, .5, "results-hypo1-4", 0);
                barchart("hypo1-romes-fd", "pathquery_romes_fd.csv", width, height, .5, "results-hypo1-4", 1);
                pos += sep;
                container.append("g")
                    .attr("id","hypo1-romel-fdfs")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("ROME large")
                    .attr("id","hypo1-romel-text")
                    .attr("x",pos)
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                textcontainer.append("text")
                    .text("p > 0.4")
                    .classed("disabled",true)
                    .attr("id","hypo1-romel-p")
                    .attr("x",pos+40)
                    .attr("y",height+80)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                container.append("g")
                    .attr("id","hypo1-romel-fd")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo1-romel-fdfs", "pathquery_romel_fdfs.csv", width, height, .5, "results-hypo1-6", 0);
                barchart("hypo1-romel-fd", "pathquery_romel_fd.csv", width, height, .5, "results-hypo1-6", 1);
                pos += sep;
                container.append("g")
                    .attr("id","hypo1-rnds-fdfs")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("Random small")
                    .attr("id","hypo1-rnds-text")
                    .attr("x",pos)
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                textcontainer.append("text")
                    .text("p < 0.01")
                    .classed("p1",true)
                    .classed("disabled",true)
                    .attr("id","hypo1-rnds-p")
                    .attr("x",pos+40)
                    .attr("y",height+80)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                container.append("g")
                    .attr("id","hypo1-rnds-fd")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo1-rnds-fdfs", "pathquery_rnds_fdfs.csv", width, height, .5, "results-hypo1-8", 0);
                barchart("hypo1-rnds-fd", "pathquery_rnds_fd.csv", width, height, .5, "results-hypo1-8", 1);
                pos += sep;
                container.append("g")
                    .attr("id","hypo1-rndl-fdfs")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("Random large")
                    .attr("id","hypo1-rndl-text")
                    .attr("x",pos)
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                textcontainer.append("text")
                    .text("p > 0.8")
                    .classed("disabled",true)
                    .attr("id","hypo1-rndl-p")
                    .attr("x",pos+40)
                    .attr("y",height+80)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                container.append("g")
                    .attr("id","hypo1-rndl-fd")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo1-rndl-fdfs", "pathquery_rndl_fdfs.csv", width, height, .5, "results-hypo1-10", 0);
                barchart("hypo1-rndl-fd", "pathquery_rndl_fd.csv", width, height, .5, "results-hypo1-10", 1);
                break;
            case "results-hypo1-5":
                textcontainer.select("#hypo1-romes-p")
                    .classed("disabled",false);
                break;
            case "results-hypo1-7":
                textcontainer.select("#hypo1-romel-p")
                    .classed("disabled",false);
                break;
            case "results-hypo1-9":
                textcontainer.select("#hypo1-rnds-p")
                    .classed("disabled",false);
                textcontainer.select("#hypo1-rnds-text")
                    .classed("p1",true);
                break;
            case "results-hypo1-11":
                textcontainer.select("#hypo1-rndl-p")
                    .classed("disabled",false);
                break;
            case "results-hypo1-12":
                svg.transition()
                    .attr("viewBox","-2500 -800 1600 1600");
                break;



            case "results-hypo1-13":
                d3.select("#results-hypo1-2").classed("disabled",false);
                pos = sep-width;
                container_time.append("g")
                    .attr("id","hypo1-all-fdfs-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer_time.append("text")
                    .text("All")
                    .attr("id","hypo1-all-text")
                    .attr("x",pos)
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                container_time.append("g")
                    .attr("id","hypo1-all-fd-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo1-all-fdfs-time", "pathquery_all_fdfs-time.csv", width, height, 20, "results-hypo1-14", 0);
                barchart("hypo1-all-fd-time", "pathquery_all_fd-time.csv", width, height, 20, "results-hypo1-14", 1);
                pos += 1.5 * sep;
                break;
            case "results-hypo1-15":
                pos = 2.5 * sep + width;
                d3.select("#hypo1-scalelines-time")
                    .selectAll("line")
                    .transition()
                    .attr("x2",700);
                d3.select("#hypo1-endline-time")
                    .transition()
                    .attr("x1",700)
                    .attr("x2",700);
                container_time.append("g")
                    .attr("id","hypo1-romes-fdfs-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer_time.append("text")
                    .text("ROME small")
                    .attr("id","hypo1-romes-text")
                    .attr("x",pos)
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                textcontainer_time.append("text")
                    .text("p < 0.01")
                    .classed("p1",true)
                    .classed("disabled",true)
                    .attr("id","hypo1-romes-p")
                    .attr("x",pos+40)
                    .attr("y",height+80)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                container_time.append("g")
                    .attr("id","hypo1-romes-fd-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo1-romes-fdfs-time", "pathquery_romes_fdfs-time.csv", width, height, 20, "results-hypo1-16", 0);
                barchart("hypo1-romes-fd-time", "pathquery_romes_fd-time.csv", width, height, 20, "results-hypo1-16", 1);
                pos += sep;
                container_time.append("g")
                    .attr("id","hypo1-romel-fdfs-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer_time.append("text")
                    .text("ROME large")
                    .attr("id","hypo1-romel-text")
                    .attr("x",pos)
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                textcontainer_time.append("text")
                    .text("p < 0.1")
                    .classed("p1",true)
                    .classed("disabled",true)
                    .attr("id","hypo1-romel-p")
                    .attr("x",pos+40)
                    .attr("y",height+80)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                container_time.append("g")
                    .attr("id","hypo1-romel-fd-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo1-romel-fdfs-time", "pathquery_romel_fdfs-time.csv", width, height, 20, "results-hypo1-18", 0);
                barchart("hypo1-romel-fd-time", "pathquery_romel_fd-time.csv", width, height, 20, "results-hypo1-18", 1);
                pos += sep;
                container_time.append("g")
                    .attr("id","hypo1-rnds-fdfs-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer_time.append("text")
                    .text("Random small")
                    .attr("id","hypo1-rnds-text")
                    .attr("x",pos)
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                textcontainer_time.append("text")
                    .text("p < 0.01")
                    .classed("p1",true)
                    .classed("disabled",true)
                    .attr("id","hypo1-rnds-p")
                    .attr("x",pos+40)
                    .attr("y",height+80)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                container_time.append("g")
                    .attr("id","hypo1-rnds-fd-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo1-rnds-fdfs-time", "pathquery_rnds_fdfs-time.csv", width, height, 20, "results-hypo1-20", 0);
                barchart("hypo1-rnds-fd-time", "pathquery_rnds_fd-time.csv", width, height, 20, "results-hypo1-20", 1);
                pos += sep;
                container_time.append("g")
                    .attr("id","hypo1-rndl-fdfs-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer_time.append("text")
                    .text("Random large")
                    .attr("id","hypo1-rndl-text")
                    .attr("x",pos)
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                textcontainer_time.append("text")
                    .text("p < 0.001")
                    .classed("p0",true)
                    .classed("disabled",true)
                    .attr("id","hypo1-rndl-p")
                    .attr("x",pos+40)
                    .attr("y",height+80)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                container_time.append("g")
                    .attr("id","hypo1-rndl-fd-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo1-rndl-fdfs-time", "pathquery_rndl_fdfs-time.csv", width, height, 20, "results-hypo1-22", 0);
                barchart("hypo1-rndl-fd-time", "pathquery_rndl_fd-time.csv", width, height, 20, "results-hypo1-22", 1);
                break;
            case "results-hypo1-17":
                textcontainer_time.select("#hypo1-romes-p")
                    .classed("disabled",false);
                textcontainer_time.select("#hypo1-romes-text")
                    .classed("p1",true);
                break;
            case "results-hypo1-19":
                textcontainer_time.select("#hypo1-romel-p")
                    .classed("disabled",false);
                textcontainer_time.select("#hypo1-romel-text")
                    .classed("p1",true);
                break;
            case "results-hypo1-21":
                textcontainer_time.select("#hypo1-rnds-p")
                    .classed("disabled",false);
                textcontainer_time.select("#hypo1-rnds-text")
                    .classed("p1",true);
                break;
            case "results-hypo1-23":
                textcontainer_time.select("#hypo1-rndl-p")
                    .classed("disabled",false);
                textcontainer_time.select("#hypo1-rndl-text")
                    .classed("p0",true);
                break;
            case "results-hypo1-24":
                svg.transition()
                    .attr("viewBox","-500 -250 600 600");
                svg_time.transition()
                    .attr("viewBox","300 -250 600 600");
                break;
            case "results-hypo1-25":
                var resdiv = section.append("div")
                    .attr("id","results-hypo1-result")
                    .style("overflow","auto")
                    .style("float","left")
                    .style("margin-left","180px")
                    .style("margin-top","-80px");
                var resbox = resdiv.append("div")
                    .attr("class","roundbox1");
                resbox.append("span")
                    .attr("class","hypothesistitle")
                    .text("H1: Result");
                resbox.append("br");
                resbox.append("span")
                    .attr("class","teletype")
                    .text("ForceDirected > ForceDirFewSeg");
        }
    });


    Reveal.addEventListener( 'fragmenthidden', function( event ) {
        var id = event.fragment.getAttribute('id');
        switch (id) {
            case "results-hypo1-1":
                container.select("#hypo1-all-fdfs")
                    .remove();
                textcontainer.select("#hypo1-all-text")
                    .remove();
                container.select("#hypo1-all-fd")
                    .remove();
                d3.select("#hypo1-all-fdfs").selectAll("*").remove();
                d3.select("#hypo1-all-fd").selectAll("*").remove();
                break;
            case "results-hypo1-3":
                d3.select("#hypo1-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",200);
                d3.select("#hypo1-endline")
                    .transition()
                    .attr("x1",200)
                    .attr("x2",200);
                container.select("#hypo1-romes-fdfs").remove();
                textcontainer.select("#hypo1-romes-text").remove();
                textcontainer.select("#hypo1-romes-p").remove();
                container.select("#hypo1-romes-fd").remove();
                container.select("#hypo1-romel-fdfs").remove();
                textcontainer.select("#hypo1-romel-text").remove();
                textcontainer.select("#hypo1-romel-p").remove();
                container.select("#hypo1-romel-fd").remove();
                container.select("#hypo1-rnds-fdfs").remove();
                textcontainer.select("#hypo1-rnds-text").remove();
                textcontainer.select("#hypo1-rnds-p").remove();
                container.select("#hypo1-rnds-fd").remove();
                container.select("#hypo1-rndl-fdfs").remove();
                textcontainer.select("#hypo1-rndl-text").remove();
                textcontainer.select("#hypo1-rndl-p").remove();
                container.select("#hypo1-rndl-fd").remove();
                break;
            case "results-hypo1-5":
                textcontainer.select("#hypo1-romes-p")
                    .classed("disabled",true);
                break;
            case "results-hypo1-7":
                textcontainer.select("#hypo1-romel-p")
                    .classed("disabled",true);
                break;
            case "results-hypo1-9":
                textcontainer.select("#hypo1-rnds-p")
                    .classed("disabled",true);
                textcontainer.select("#hypo1-rnds-text")
                    .classed("p1",false);
                break;
            case "results-hypo1-11":
                textcontainer.select("#hypo1-rndl-p")
                    .classed("disabled",true);
                break;
            case "results-hypo1-12":
                svg.transition()
                    .attr("viewBox","180 0 440 440");
                break;
            case "results-hypo1-13":
                d3.select("#results-hypo1-2").classed("disabled",true);
                container_time.select("#hypo1-all-fdfs-time").remove();
                textcontainer_time.select("#hypo1-all-text").remove();
                container_time.select("#hypo1-all-fd-time").remove();
                break;
            case "results-hypo1-15":
                d3.select("#hypo1-scalelines-time")
                    .selectAll("line")
                    .transition()
                    .attr("x2",200);
                d3.select("#hypo1-endline-time")
                    .transition()
                    .attr("x1",200)
                    .attr("x2",200);
                container_time.select("#hypo1-romes-fdfs-time").remove();
                textcontainer_time.select("#hypo1-romes-text").remove();
                textcontainer_time.select("#hypo1-romes-p").remove();
                container_time.select("#hypo1-romes-fd-time").remove();
                container_time.select("#hypo1-romel-fdfs-time").remove();
                textcontainer_time.select("#hypo1-romel-text").remove();
                textcontainer_time.select("#hypo1-romel-p").remove();
                container_time.select("#hypo1-romel-fd-time").remove();
                container_time.select("#hypo1-rnds-fdfs-time").remove();
                textcontainer_time.select("#hypo1-rnds-text").remove();
                textcontainer_time.select("#hypo1-rnds-p").remove();
                container_time.select("#hypo1-rnds-fd-time").remove();
                container_time.select("#hypo1-rndl-fdfs-time").remove();
                textcontainer_time.select("#hypo1-rndl-text").remove();
                textcontainer_time.select("#hypo1-rndl-p").remove();
                container_time.select("#hypo1-rndl-fd-time").remove();
                break;
            case "results-hypo1-17":
                textcontainer_time.select("#hypo1-romes-p")
                    .classed("disabled",true);
                textcontainer_time.select("#hypo1-romes-text")
                    .classed("p1",false);
                break;
            case "results-hypo1-19":
                textcontainer_time.select("#hypo1-romel-p")
                    .classed("disabled",true);
                textcontainer_time.select("#hypo1-romel-text")
                    .classed("p1",false);
                break;
            case "results-hypo1-21":
                textcontainer_time.select("#hypo1-rnds-p")
                    .classed("disabled",true);
                textcontainer_time.select("#hypo1-rnds-text")
                    .classed("p1",false);
                break;
            case "results-hypo1-23":
                textcontainer_time.select("#hypo1-rndl-p")
                    .classed("disabled",true);
                textcontainer_time.select("#hypo1-rndl-text")
                    .classed("p0",false);
                break;
            case "results-hypo1-24":
                svg.transition()
                    .attr("viewBox","-2500 -800 1600 1600");
                svg_time.transition()
                    .attr("viewBox","180 0 440 440");
                break;
            case "results-hypo1-25":
                section.select("#results-hypo1-result").remove();
        }
    });
}

















function resultsHypothesis3() {
    var width = 30;
    var height = 440;
    var sep = 30;
    var section = d3.select("#section-results-hypo3");
    var svg = section.select("#results-hypo3-compchart");
    var svg_time = section.select("#results-hypo3-compchart-time");
    var container = section.select("#results-hypo3-cont");
    var container_time = section.select("#results-hypo3-cont-time");
    var textcontainer = container.append("g").attr("class","scaletext");
    var textcontainer_time = container_time.append("g").attr("class","scaletext");
    var pos = sep - width;


    Reveal.addEventListener( 'fragmentshown', function( event ) {
        var id = event.fragment.getAttribute('id');
        switch (id) {
            case "results-hypo3-1":
                pos = 10;
                container.append("g")
                    .attr("id","hypo3-all-fewseg")
                    .attr("transform","translate("+(pos += width)+",0)");
                container.append("g")
                    .attr("id","hypo3-all-tidier")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("All")
                    .attr("id","hypo3-all-text")
                    .attr("x",pos+(width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                var p = textcontainer.append("g")
                    .attr("id","hypo3-all-p")
                    .classed("disabled",true)
                    .attr("transform","translate("+(pos+(width/2))+","+(height+80)+")");
                p.append("text")
                    .attr("x",0)
                    .attr("y",0)
                    .attr("class","ptext0")
                    .text("F");
                p.append("text")
                    .attr("x",-width/6)
                    .attr("y",width)
                    .attr("class","prel")
                    .attr("transform","rotate(-60," + (-width/2) + "," + (5/6*width) + ")")
                    .text("=");
                p.append("text")
                    .attr("x",-width)
                    .attr("y",5/3*width)
                    .attr("class","ptext1")
                    .text("T");
                p.append("text")
                    .attr("x",6)
                    .attr("y",31)
                    .attr("transform","rotate(60," + (width/2) + "," + (5/6*width) + ")")
                    .attr("class","prel ptext0")
                    .text(">");
                p.append("text")
                    .attr("x",width)
                    .attr("y",5/3*width)
                    .attr("class","ptext2")
                    .text("Q");
                p.append("text")
                    .attr("x",-2)
                    .attr("y",5/3*width)
                    .attr("class","ptext1")
                    .html("&#8811;");
                container.append("g")
                    .attr("id","hypo3-all-quad")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo3-all-fewseg", "treequery_all_fewseg.csv", width, height, .5, "results-hypo3-2", 0);
                barchart("hypo3-all-tidier", "treequery_all_tidier.csv", width, height, .5, "results-hypo3-2", 1);
                barchart("hypo3-all-quad", "treequery_all_quad.csv", width, height, .5, "results-hypo3-2", 2);
                break;
            case "results-hypo3-3":
                textcontainer.select("#hypo3-all-p").classed("disabled",false);
                break;
            case "results-hypo3-4":
                pos = 2.5 * sep + 2 * width;
                d3.select("#hypo3-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",500);
                d3.select("#hypo3-endline")
                    .transition()
                    .attr("x1",500)
                    .attr("x2",500);
                container.append("g")
                    .attr("id","hypo3-small-fewseg")
                    .attr("transform","translate("+(pos += width)+",0)");
                container.append("g")
                    .attr("id","hypo3-small-tidier")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("Small")
                    .attr("id","hypo3-small-text")
                    .attr("x",pos+(width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                p = textcontainer.append("g")
                    .attr("id","hypo3-small-p")
                    .classed("disabled",true)
                    .attr("transform","translate("+(pos+(width/2))+","+(height+80)+")");
                p.append("text")
                    .attr("x",0)
                    .attr("y",0)
                    .attr("class","ptext0")
                    .text("F");
                p.append("text")
                    .attr("x",-width/6)
                    .attr("y",width)
                    .attr("class","prel")
                    .attr("transform","rotate(-60," + (-width/2) + "," + (5/6*width) + ")")
                    .text("=");
                p.append("text")
                    .attr("x",-width)
                    .attr("y",5/3*width)
                    .attr("class","ptext1")
                    .text("T");
                p.append("text")
                    .attr("x",6)
                    .attr("y",31)
                    .attr("transform","rotate(60," + (width/2) + "," + (5/6*width) + ")")
                    .attr("class","ptext0 prel")
                    .html("&gt;");
                p.append("text")
                    .attr("x",width)
                    .attr("y",5/3*width)
                    .attr("class","ptext2")
                    .text("Q");
                p.append("text")
                    .attr("x",-2)
                    .attr("y",5/3*width)
                    .attr("class","prel")
                    .html("=");
                container.append("g")
                    .attr("id","hypo3-small-quad")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo3-small-fewseg", "treequery_small_fewseg.csv", width, height, .5, "results-hypo3-5", 0);
                barchart("hypo3-small-tidier", "treequery_small_tidier.csv", width, height, .5, "results-hypo3-5", 1);
                barchart("hypo3-small-quad", "treequery_small_quad.csv", width, height, .5, "results-hypo3-5", 2);
                pos += sep;
                container.append("g")
                    .attr("id","hypo3-large-fewseg")
                    .attr("transform","translate("+(pos += width)+",0)");
                container.append("g")
                    .attr("id","hypo3-large-tidier")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("Large")
                    .attr("id","hypo3-large-text")
                    .attr("x",pos+(width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                p = textcontainer.append("g")
                    .attr("id","hypo3-large-p")
                    .classed("disabled",true)
                    .attr("transform","translate("+(pos+(width/2))+","+(height+80)+")");
                p.append("text")
                    .attr("x",0)
                    .attr("y",0)
                    .attr("class","ptext0")
                    .text("F");
                p.append("text")
                    .attr("x",-width/6)
                    .attr("y",width)
                    .attr("class","prel")
                    .attr("transform","rotate(-60," + (-width/2) + "," + (5/6*width) + ")")
                    .text("=");
                p.append("text")
                    .attr("x",-width)
                    .attr("y",5/3*width)
                    .attr("class","ptext1")
                    .text("T");
                p.append("text")
                    .attr("x",6)
                    .attr("y",31)
                    .attr("transform","rotate(60," + (width/2) + "," + (5/6*width) + ")")
                    .attr("class","ptext0 prel")
                    .html("&gt;");
                p.append("text")
                    .attr("x",width)
                    .attr("y",5/3*width)
                    .attr("class","ptext2")
                    .text("Q");
                p.append("text")
                    .attr("x",-2)
                    .attr("y",5/3*width)
                    .attr("class","ptext1")
                    .html("&#8811;");
                container.append("g")
                    .attr("id","hypo3-large-quad")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo3-large-fewseg", "treequery_large_fewseg.csv", width, height, .5, "results-hypo3-7", 0);
                barchart("hypo3-large-tidier", "treequery_large_tidier.csv", width, height, .5, "results-hypo3-7", 1);
                barchart("hypo3-large-quad", "treequery_large_quad.csv", width, height, .5, "results-hypo3-7", 2);
                break;
            case "results-hypo3-6":
                textcontainer.select("#hypo3-small-p")
                    .classed("disabled",false);
                break;
            case "results-hypo3-8":
                textcontainer.select("#hypo3-large-p")
                    .classed("disabled",false);
                break;
            case "results-hypo3-9":
                pos = 5 * sep + 8 * width;
                d3.select("#hypo3-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",800);
                d3.select("#hypo3-endline")
                    .transition()
                    .attr("x1",800)
                    .attr("x2",800);
                container.append("g")
                    .attr("id","hypo3-balanced-fewseg")
                    .attr("transform","translate("+(pos += width)+",0)");
                container.append("g")
                    .attr("id","hypo3-balanced-tidier")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("Balanced")
                    .attr("id","hypo3-balanced-text")
                    .attr("x",pos+(width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                container.append("g")
                    .attr("id","hypo3-balanced-quad")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo3-balanced-fewseg", "treequery_balanced_fewseg.csv", width, height, .5, "results-hypo3-10", 0);
                barchart("hypo3-balanced-tidier", "treequery_balanced_tidier.csv", width, height, .5, "results-hypo3-10", 1);
                barchart("hypo3-balanced-quad", "treequery_balanced_quad.csv", width, height, .5, "results-hypo3-10", 2);
                pos += sep;
                container.append("g")
                    .attr("id","hypo3-deep-fewseg")
                    .attr("transform","translate("+(pos += width)+",0)");
                container.append("g")
                    .attr("id","hypo3-deep-tidier")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("Deep")
                    .attr("id","hypo3-deep-text")
                    .attr("x",pos+(width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                container.append("g")
                    .attr("id","hypo3-deep-quad")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo3-deep-fewseg", "treequery_deep_fewseg.csv", width, height, .5, "results-hypo3-11", 0);
                barchart("hypo3-deep-tidier", "treequery_deep_tidier.csv", width, height, .5, "results-hypo3-11", 1);
                barchart("hypo3-deep-quad", "treequery_deep_quad.csv", width, height, .5, "results-hypo3-11", 2);
                pos += sep;
                container.append("g")
                    .attr("id","hypo3-wide-fewseg")
                    .attr("transform","translate("+(pos += width)+",0)");
                container.append("g")
                    .attr("id","hypo3-wide-tidier")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("Wide")
                    .attr("id","hypo3-wide-text")
                    .attr("x",pos+(width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                container.append("g")
                    .attr("id","hypo3-wide-quad")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo3-wide-fewseg", "treequery_wide_fewseg.csv", width, height, .5, "results-hypo3-12", 0);
                barchart("hypo3-wide-tidier", "treequery_wide_tidier.csv", width, height, .5, "results-hypo3-12", 1);
                barchart("hypo3-wide-quad", "treequery_wide_quad.csv", width, height, .5, "results-hypo3-12", 2);
                break;
            case "results-hypo3-13":
                svg.transition()
                    .attr("viewBox","-2500 -1500 1600 1600");
                break;

                
                
                
            case "results-hypo3-14":
                pos = 10;
                d3.select("#results-hypo3-2").classed("disabled",false);
                container_time.append("g")
                    .attr("id","hypo3-all-fewseg-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                container_time.append("g")
                    .attr("id","hypo3-all-tidier-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer_time.append("text")
                    .text("All")
                    .attr("id","hypo3-all-text-time")
                    .attr("x",pos+(width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                p = textcontainer_time.append("g")
                    .attr("id","hypo3-all-p-time")
                    .classed("disabled",true)
                    .attr("transform","translate("+(pos+(width/2))+","+(height+80)+")");
                p.append("text")
                    .attr("x",0)
                    .attr("y",0)
                    .attr("class","ptext0")
                    .text("F");
                p.append("text")
                    .attr("x",-5)
                    .attr("y",28)
                    .attr("class","ptext1")
                    .attr("transform","rotate(-60," + (-width/2) + "," + (5/6*width) + ")")
                    .html("&#8811;");
                p.append("text")
                    .attr("x",-width)
                    .attr("y",5/3*width)
                    .attr("class","ptext1")
                    .text("T");
                p.append("text")
                    .attr("x",4)
                    .attr("y",32)
                    .attr("transform","rotate(60," + (width/2) + "," + (5/6*width) + ")")
                    .attr("class","ptext2 prel")
                    .html("&lt;");
                p.append("text")
                    .attr("x",width)
                    .attr("y",5/3*width)
                    .attr("class","ptext2")
                    .text("Q");
                p.append("text")
                    .attr("x",-2)
                    .attr("y",5/3*width)
                    .attr("class","prel")
                    .html("=");
                container_time.append("g")
                    .attr("id","hypo3-all-quad-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo3-all-fewseg-time", "treequery_all_fewseg-time.csv", width, height, 20, "results-hypo3-15", 0);
                barchart("hypo3-all-tidier-time", "treequery_all_tidier-time.csv", width, height, 20, "results-hypo3-15", 1);
                barchart("hypo3-all-quad-time", "treequery_all_quad-time.csv", width, height, 20, "results-hypo3-15", 2);
                break;
            case "results-hypo3-16":
                textcontainer_time.select("#hypo3-all-p-time").classed("disabled",false);
                break;
            case "results-hypo3-17":
                pos = 2.5 * sep + 2 * width;
                d3.select("#hypo3-scalelines-time")
                    .selectAll("line")
                    .transition()
                    .attr("x2",500);
                d3.select("#hypo3-endline-time")
                    .transition()
                    .attr("x1",500)
                    .attr("x2",500);
                container_time.append("g")
                    .attr("id","hypo3-small-fewseg-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                container_time.append("g")
                    .attr("id","hypo3-small-tidier-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer_time.append("text")
                    .text("Small")
                    .attr("id","hypo3-small-text-time")
                    .attr("x",pos+(width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                p = textcontainer_time.append("g")
                    .attr("id","hypo3-small-p-time")
                    .classed("disabled",true)
                    .attr("transform","translate("+(pos+(width/2))+","+(height+80)+")");
                p.append("text")
                    .attr("x",0)
                    .attr("y",0)
                    .attr("class","ptext0")
                    .text("F");
                p.append("text")
                    .attr("x",-5)
                    .attr("y",28)
                    .attr("class","prel")
                    .attr("transform","rotate(-60," + (-width/2) + "," + (5/6*width) + ")")
                    .html("=");
                p.append("text")
                    .attr("x",-width)
                    .attr("y",5/3*width)
                    .attr("class","ptext1")
                    .text("T");
                p.append("text")
                    .attr("x",4)
                    .attr("y",30)
                    .attr("transform","rotate(60," + (width/2) + "," + (5/6*width) + ")")
                    .attr("class","prel")
                    .html("=");
                p.append("text")
                    .attr("x",width)
                    .attr("y",5/3*width)
                    .attr("class","ptext2")
                    .text("Q");
                p.append("text")
                    .attr("x",-2)
                    .attr("y",5/3*width)
                    .attr("class","prel")
                    .html("=");
                container_time.append("g")
                    .attr("id","hypo3-small-quad-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo3-small-fewseg-time", "treequery_small_fewseg-time.csv", width, height, 20, "results-hypo3-18", 0);
                barchart("hypo3-small-tidier-time", "treequery_small_tidier-time.csv", width, height, 20, "results-hypo3-18", 1);
                barchart("hypo3-small-quad-time", "treequery_small_quad-time.csv", width, height, 20, "results-hypo3-18", 2);
                pos += sep;
                container_time.append("g")
                    .attr("id","hypo3-large-fewseg-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                container_time.append("g")
                    .attr("id","hypo3-large-tidier-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer_time.append("text")
                    .text("Large")
                    .attr("id","hypo3-large-text-time")
                    .attr("x",pos+(width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                p = textcontainer_time.append("g")
                    .attr("id","hypo3-large-p-time")
                    .classed("disabled",true)
                    .attr("transform","translate("+(pos+(width/2))+","+(height+80)+")");
                p.append("text")
                    .attr("x",0)
                    .attr("y",0)
                    .attr("class","ptext0")
                    .text("F");
                p.append("text")
                    .attr("x",-5)
                    .attr("y",28)
                    .attr("class","ptext1")
                    .attr("transform","rotate(-60," + (-width/2) + "," + (5/6*width) + ")")
                    .html("&#8811;");
                p.append("text")
                    .attr("x",-width)
                    .attr("y",5/3*width)
                    .attr("class","ptext1")
                    .text("T");
                p.append("text")
                    .attr("x",4)
                    .attr("y",32)
                    .attr("transform","rotate(60," + (width/2) + "," + (5/6*width) + ")")
                    .attr("class","ptext2 prel")
                    .html("&lt;");
                p.append("text")
                    .attr("x",width)
                    .attr("y",5/3*width)
                    .attr("class","ptext2")
                    .text("Q");
                p.append("text")
                    .attr("x",-2)
                    .attr("y",5/3*width)
                    .attr("class","prel")
                    .html("=");
                container_time.append("g")
                    .attr("id","hypo3-large-quad-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo3-large-fewseg-time", "treequery_large_fewseg-time.csv", width, height, 20, "results-hypo3-20", 0);
                barchart("hypo3-large-tidier-time", "treequery_large_tidier-time.csv", width, height, 20, "results-hypo3-20", 1);
                barchart("hypo3-large-quad-time", "treequery_large_quad-time.csv", width, height, 20, "results-hypo3-20", 2);
                break;
            case "results-hypo3-19":
                textcontainer_time.select("#hypo3-small-p-time")
                    .classed("disabled",false);
                break;
            case "results-hypo3-21":
                textcontainer_time.select("#hypo3-large-p-time")
                    .classed("disabled",false);
                break;
            case "results-hypo3-22":
                pos = 5 * sep + 8 * width;
                d3.select("#hypo3-scalelines-time")
                    .selectAll("line")
                    .transition()
                    .attr("x2",800);
                d3.select("#hypo3-endline-time")
                    .transition()
                    .attr("x1",800)
                    .attr("x2",800);
                container_time.append("g")
                    .attr("id","hypo3-balanced-fewseg-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                container_time.append("g")
                    .attr("id","hypo3-balanced-tidier-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer_time.append("text")
                    .text("Balanced")
                    .attr("id","hypo3-balanced-text-time")
                    .attr("x",pos+(width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                container_time.append("g")
                    .attr("id","hypo3-balanced-quad-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo3-balanced-fewseg-time", "treequery_balanced_fewseg-time.csv", width, height, 20, "results-hypo3-23", 0);
                barchart("hypo3-balanced-tidier-time", "treequery_balanced_tidier-time.csv", width, height, 20, "results-hypo3-23", 1);
                barchart("hypo3-balanced-quad-time", "treequery_balanced_quad-time.csv", width, height, 20, "results-hypo3-23", 2);
                pos += sep;
                container_time.append("g")
                    .attr("id","hypo3-deep-fewseg-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                container_time.append("g")
                    .attr("id","hypo3-deep-tidier-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer_time.append("text")
                    .text("Deep")
                    .attr("id","hypo3-deep-text-time")
                    .attr("x",pos+(width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                container_time.append("g")
                    .attr("id","hypo3-deep-quad-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo3-deep-fewseg-time", "treequery_deep_fewseg-time.csv", width, height, 20, "results-hypo3-24", 0);
                barchart("hypo3-deep-tidier-time", "treequery_deep_tidier-time.csv", width, height, 20, "results-hypo3-24", 1);
                barchart("hypo3-deep-quad-time", "treequery_deep_quad-time.csv", width, height, 20, "results-hypo3-24", 2);
                pos += sep;
                container_time.append("g")
                    .attr("id","hypo3-wide-fewseg-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                container_time.append("g")
                    .attr("id","hypo3-wide-tidier-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer_time.append("text")
                    .text("Wide")
                    .attr("id","hypo3-wide-text-time")
                    .attr("x",pos+(width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                container_time.append("g")
                    .attr("id","hypo3-wide-quad-time")
                    .attr("transform","translate("+(pos += width)+",0)");
                barchart("hypo3-wide-fewseg-time", "treequery_wide_fewseg-time.csv", width, height, 20, "results-hypo3-25", 0);
                barchart("hypo3-wide-tidier-time", "treequery_wide_tidier-time.csv", width, height, 20, "results-hypo3-25", 1);
                barchart("hypo3-wide-quad-time", "treequery_wide_quad-time.csv", width, height, 20, "results-hypo3-25", 2);
                break;






            case "results-hypo3-26":
                d3.select("#hypo3-ratinglegend").classed("disabled",true);
                svg.transition()
                    .attr("viewBox","-550 -350 700 700");
                svg_time.transition()
                    .attr("viewBox","300 -350 700 700");
                break;
            case "results-hypo3-27":
                var resdiv = section.append("div")
                    .attr("id","results-hypo3-result")
                    .style("overflow","auto")
                    .style("float","left")
                    .style("margin-left","400px")
                    .style("margin-top","-80px");
                var resbox = resdiv.append("div")
                    .attr("class","roundbox1");
                resbox.append("span")
                    .attr("class","hypothesistitle")
                    .text("H3: Result");
                resbox.append("br");
                resbox.append("span")
                    .attr("class","teletype")
                    .html("Tidier > FewSeg > Quad");
        }
    });



    Reveal.addEventListener( 'fragmenthidden', function( event ) {
        var id = event.fragment.getAttribute('id');
        switch (id) {
            case "results-hypo3-1":
                container.select("#hypo3-all-fewseg").remove();
                container.select("#hypo3-all-tidier").remove();
                textcontainer.select("#hypo3-all-text").remove();
                textcontainer.select("#hypo3-all-p").remove();
                container.select("#hypo3-all-quad").remove();
                break;
            case "results-hypo3-3":
                textcontainer.select("#hypo3-all-p").classed("disabled",true);
                break;
            case "results-hypo3-4":
                d3.select("#hypo3-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",200);
                d3.select("#hypo3-endline")
                    .transition()
                    .attr("x1",200)
                    .attr("x2",200);
                container.select("#hypo3-small-fewseg").remove();
                container.select("#hypo3-small-tidier").remove();
                textcontainer.select("#hypo3-small-text").remove();
                p = textcontainer.select("#hypo3-small-p").remove();
                container.select("#hypo3-small-quad").remove();
                container.select("#hypo3-large-fewseg").remove();
                container.select("#hypo3-large-tidier").remove();
                textcontainer.select("#hypo3-large-text").remove();
                p = textcontainer.select("#hypo3-large-p").remove();
                container.select("#hypo3-large-quad").remove();
                break;
            case "results-hypo3-6":
                textcontainer.select("#hypo3-small-p")
                    .classed("disabled",true);
                break;
            case "results-hypo3-8":
                textcontainer.select("#hypo3-large-p")
                    .classed("disabled",true);
                break;
            case "results-hypo3-9":
                d3.select("#hypo3-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",500);
                d3.select("#hypo3-endline")
                    .transition()
                    .attr("x1",500)
                    .attr("x2",500);
                container.select("#hypo3-balanced-fewseg").remove();
                container.select("#hypo3-balanced-tidier").remove();
                textcontainer.select("#hypo3-balanced-text").remove();
                p = textcontainer.select("#hypo3-balanced-p").remove();
                container.select("#hypo3-balanced-quad").remove();
                container.select("#hypo3-deep-fewseg").remove();
                container.select("#hypo3-deep-tidier").remove();
                textcontainer.select("#hypo3-deep-text").remove();
                p = textcontainer.select("#hypo3-deep-p").remove();
                container.select("#hypo3-deep-quad").remove();
                container.select("#hypo3-wide-fewseg").remove();
                container.select("#hypo3-wide-tidier").remove();
                textcontainer.select("#hypo3-wide-text").remove();
                p = textcontainer.select("#hypo3-wide-p").remove();
                container.select("#hypo3-wide-quad").remove();
                break;
            case "results-hypo3-13":
                svg.transition()
                    .attr("viewBox","230 0 440 440");
                break;




            case "results-hypo3-14":
                d3.select("#results-hypo3-2").classed("disabled",true);
                container_time.select("hypo3-all-fewseg-time").remove();
                container_time.select("#hypo3-all-tidier-time").remove();
                textcontainer_time.select("#hypo3-all-text-time").remove();
                textcontainer_time.select("#hypo3-all-p-time").remove();
                container_time.select("#hypo3-all-quad-time").remove();
                break;
            case "results-hypo3-16":
                textcontainer_time.select("#hypo3-all-p-time").classed("disabled",true);
                break;
            case "results-hypo3-17":
                d3.select("#hypo3-scalelines-time")
                    .selectAll("line")
                    .transition()
                    .attr("x2",200);
                d3.select("#hypo3-endline-time")
                    .transition()
                    .attr("x1",200)
                    .attr("x2",200);
                container_time.select("#hypo3-small-fewseg-time").remove();
                container_time.select("#hypo3-small-tidier-time").remove();
                textcontainer_time.select("#hypo3-small-text-time").remove();
                textcontainer_time.select("#hypo3-small-p-time").remove();
                container_time.select("#hypo3-small-quad-time").remove();
                container_time.select("#hypo3-large-fewseg-time").remove();
                container_time.select("#hypo3-large-tidier-time").remove();
                textcontainer_time.select("#hypo3-large-text-time").remove();
                textcontainer_time.select("#hypo3-large-p-time").remove();
                container_time.select("#hypo3-large-quad-time").remove();
                break;
            case "results-hypo3-19":
                textcontainer_time.select("#hypo3-small-p-time")
                    .classed("disabled",true);
                break;
            case "results-hypo3-21":
                textcontainer_time.select("#hypo3-large-p-time")
                    .classed("disabled",true);
                break;
            case "results-hypo3-22":
                d3.select("#hypo3-scalelines-time")
                    .selectAll("line")
                    .transition()
                    .attr("x2",500);
                d3.select("#hypo3-endline-time")
                    .transition()
                    .attr("x1",500)
                    .attr("x2",500);
                container_time.select("#hypo3-balanced-fewseg-time").remove();
                container_time.select("#hypo3-balanced-tidier-time").remove();
                textcontainer_time.select("#hypo3-balanced-text-time").remove();
                textcontainer_time.select("#hypo3-balanced-p-time").remove();
                container_time.select("#hypo3-balanced-quad-time").remove();
                container_time.select("#hypo3-deep-fewseg-time").remove();
                container_time.select("#hypo3-deep-tidier-time").remove();
                textcontainer_time.select("#hypo3-deep-text-time").remove();
                textcontainer_time.select("#hypo3-deep-p-time").remove();
                container_time.select("#hypo3-deep-quad-time").remove();
                container_time.select("#hypo3-wide-fewseg-time").remove();
                container_time.select("#hypo3-wide-tidier-time").remove();
                textcontainer_time.select("#hypo3-wide-text-time").remove();
                textcontainer_time.select("#hypo3-wide-p-time").remove();
                container_time.select("#hypo3-wide-quad-time").remove();
                break;






            case "results-hypo3-26":
                d3.select("#hypo3-ratinglegend").classed("disabled",false);
                svg.transition()
                    .attr("viewBox","-2500 -1500 1600 1600");
                svg_time.transition()
                    .attr("viewBox","180 0 440 440");
                break;
            case "results-hypo3-27":
                section.select("#results-hypo3-result").remove();
        }
    });
}






















function resultsHypothesis2() {
    var width = 50;
    var height = 440;
    var sep = 50;
    var section = d3.select("#section-results-hypo2");
    var svg = section.select("#results-hypo2-compchart");
    var container = section.select("#results-hypo2-cont");
    var textcontainer = container.append("g").attr("class","scaletext");
    var pos = sep - width;


    Reveal.addEventListener( 'fragmentshown', function( event ) {
        var id = event.fragment.getAttribute('id');
        switch (id) {
            case "results-hypo2-1":
                pos = sep - width;
                container.append("g")
                    .attr("id","hypo2-all")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("All")
                    .attr("id","hypo2-all-text")
                    .attr("x",pos-(width/2))
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                forcestackchart("hypo2-all", "forceaesth_all.csv", width, height, 1, "results-hypo2-2");
                break;
            case "results-hypo2-3":
                pos = 1.5 * sep + width;
                d3.select("#hypo2-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",600);
                d3.select("#hypo2-endline")
                    .transition()
                    .attr("x1",600)
                    .attr("x2",600);
                container.append("g")
                    .attr("id","hypo2-romes")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("ROME small")
                    .attr("id","hypo2-romes-text")
                    .attr("x",pos-(width/2))
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                forcestackchart("hypo2-romes", "forceaesth_romes.csv", width, height, 1, "results-hypo2-4");
                pos += sep;
                container.append("g")
                    .attr("id","hypo2-romel")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("ROME large")
                    .attr("id","hypo2-romel-text")
                    .attr("x",pos-(width/2))
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                forcestackchart("hypo2-romel", "forceaesth_romel.csv", width, height, 1, "results-hypo2-4");
                pos += sep;
                container.append("g")
                    .attr("id","hypo2-rnds")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("Random small")
                    .attr("id","hypo2-rnds-text")
                    .attr("x",pos-(width/2))
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                forcestackchart("hypo2-rnds", "forceaesth_rnds.csv", width, height, 1, "results-hypo2-4");
                pos += sep;
                container.append("g")
                    .attr("id","hypo2-rndl")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("Random large")
                    .attr("id","hypo2-rndl-text")
                    .attr("x",pos-(width/2))
                    .attr("y",height+40)
                    .attr("transform","translate("+(width/2)+ ",0) rotate(45,"+pos+","+(height+40)+")");
                forcestackchart("hypo2-rndl", "forceaesth_rndl.csv", width, height, 1, "results-hypo2-4");
                break;
            case "results-hypo2-5":
                var zoomPadding = 40;
                var revealScale = Reveal.getScale();
                var bounds = d3.select("#hypo2-zoomline").node().getBoundingClientRect();
                zoom.to({
                    x: ( bounds.left * revealScale ) - 2 * zoomPadding,
                    y: ( bounds.top * revealScale ) - zoomPadding,
                    width: ( bounds.width * revealScale ) + ( zoomPadding * 2 ),
                    height: ( bounds.height * revealScale ) + ( zoomPadding * 2 ),
                    pan: false
                });
                break;
            case "results-hypo2-6":
                zoom.out();
                break;
            case "results-hypo2-7":
                textcontainer.select("#hypo2-all-text")
                    .classed("p1",true);
                textcontainer.select("#hypo2-romel-text")
                    .classed("p0",true);
                textcontainer.select("#hypo2-rnds-text")
                    .classed("p1",true);
                textcontainer.select("#hypo2-rndl-text")
                    .classed("p1",true);
                break;
            case "results-hypo2-8":
                var resdiv = section.append("div")
                    .attr("id","results-hypo2-result")
                    .style("overflow","auto")
                    .style("float","left")
                    .style("margin-left","180px")
                    .style("margin-top","-140px");
                var resbox = resdiv.append("div")
                    .attr("class","roundbox1");
                resbox.append("span")
                    .attr("class","hypothesistitle")
                    .text("H2: Result");
                resbox.append("br");
                resbox.append("span")
                    .attr("class","teletype")
                    .html("ForceDirected &ge; ForceDirFewSeg");
        }
    });


    Reveal.addEventListener( 'fragmenthidden', function( event ) {
        var id = event.fragment.getAttribute('id');
        switch (id) {
            case "results-hypo2-1":
                container.select("#hypo2-all").remove();
                container.select("#hypo2-all-text").remove();
                break;
            case "results-hypo2-3":
                d3.select("#hypo2-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",200);
                d3.select("#hypo2-endline")
                    .transition()
                    .attr("x1",200)
                    .attr("x2",200);
                container.select("#hypo2-romes").remove();
                container.select("#hypo2-romes-text").remove();
                container.select("#hypo2-romel").remove();
                container.select("#hypo2-romel-text").remove();
                container.select("#hypo2-rnds").remove();
                container.select("#hypo2-rnds-text").remove();
                container.select("#hypo2-rndl").remove();
                container.select("#hypo2-rndl-text").remove();
                break;
            case "results-hypo2-5":
                zoom.out();
                break;
            case "results-hypo2-6":
                var zoomPadding = 40;
                var revealScale = Reveal.getScale();
                var bounds = d3.select("#hypo2-zoomline").node().getBoundingClientRect();
                zoom.to({
                    x: ( bounds.left * revealScale ) - 2 * zoomPadding,
                    y: ( bounds.top * revealScale ) - zoomPadding,
                    width: ( bounds.width * revealScale ) + ( zoomPadding * 2 ),
                    height: ( bounds.height * revealScale ) + ( zoomPadding * 2 ),
                    pan: false
                });
                break;
            case "results-hypo2-7":
                textcontainer.select("#hypo2-all-text")
                    .classed("p1",false);
                textcontainer.select("#hypo2-romel-text")
                    .classed("p0",false);
                textcontainer.select("#hypo2-rnds-text")
                    .classed("p1",false);
                textcontainer.select("#hypo2-rndl-text")
                    .classed("p1",false);
                break;
            case "results-hypo2-8":
                section.select("#results-hypo2-result").remove();
        }
    });
}




function resultsHypothesis4() {
    var width = 30;
    var height = 440;
    var sep = 40;
    var section = d3.select("#section-results-hypo4");
    var svg = section.select("#results-hypo4-compchart");
    var container = section.select("#results-hypo4-cont");
    var textcontainer = container.append("g").attr("class","scaletext");
    var pos = sep - width;


    Reveal.addEventListener( 'fragmentshown', function( event ) {
        var id = event.fragment.getAttribute('id');
        switch (id) {
            case "results-hypo4-1":
                pos = sep - width;
                container.append("g")
                    .attr("id","hypo4-all")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("All")
                    .attr("id","hypo4-all-text")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                textcontainer.append("text")
                    .text("504")
                    .classed("disabled",true)
                    .attr("id","hypo4-all-resp")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+80)
                    .style("text-anchor","middle");
                textcontainer.append("text")
                    .text("1080")
                    .classed("disabled",true)
                    .attr("id","hypo4-all-fu")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+120)
                    .style("text-anchor","middle");
                treestackchart("hypo4-all", "treeaesth_all.csv", width, height, 1, "results-hypo4-2", "results-hypo4-3");
                break;
            case "results-hypo4-3":
                textcontainer.select("#hypo4-all-text").classed("p1",true);
                break;
            case "results-hypo4-4":
                pos = 1.5 * sep + 3 * width;
                d3.select("#hypo4-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",310);
                d3.select("#hypo4-endline")
                    .transition()
                    .attr("x1",310)
                    .attr("x2",310);
                container.append("g")
                    .attr("id","hypo4-mathcs")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("MathCS")
                    .attr("id","hypo4-mathcs-text")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                textcontainer.append("text")
                    .text("476")
                    .classed("disabled",true)
                    .attr("id","hypo4-mathcs-resp")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+80)
                    .style("text-anchor","middle");
                textcontainer.append("text")
                    .text("742")
                    .classed("disabled",true)
                    .attr("id","hypo4-mathcs-fu")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+120)
                    .style("text-anchor","middle");
                treestackchart("hypo4-mathcs", "treeaesth_mathcs.csv", width, height, 1, "results-hypo4-5", "results-hypo4-6");
                break;
            case "results-hypo4-6":
                textcontainer.select("#hypo4-mathcs-text").classed("p1",true);
                break;
            case "results-hypo4-7":
                pos = 2.5 * sep + 6 * width;
                d3.select("#hypo4-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",570);
                d3.select("#hypo4-endline")
                    .transition()
                    .attr("x1",570)
                    .attr("x2",570);
                container.append("g")
                    .attr("id","hypo4-math")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("Math")
                    .attr("id","hypo4-math-text")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                textcontainer.append("text")
                    .text("164")
                    .classed("disabled",true)
                    .attr("id","hypo4-math-resp")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+80)
                    .style("text-anchor","middle");
                textcontainer.append("text")
                    .text("286")
                    .classed("disabled",true)
                    .attr("id","hypo4-math-fu")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+120)
                    .style("text-anchor","middle");
                treestackchart("hypo4-math", "treeaesth_math.csv", width, height, 1, "results-hypo4-8", "results-hypo4-9");
                pos += sep + 2 * width;
                container.append("g")
                    .attr("id","hypo4-cs")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("CS")
                    .attr("id","hypo4-cs-text")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                textcontainer.append("text")
                    .text("428")
                    .classed("disabled",true)
                    .attr("id","hypo4-cs-resp")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+80)
                    .style("text-anchor","middle");
                textcontainer.append("text")
                    .text("646")
                    .classed("disabled",true)
                    .attr("id","hypo4-cs-fu")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+120)
                    .style("text-anchor","middle");
                treestackchart("hypo4-cs", "treeaesth_cs.csv", width, height, 1, "results-hypo4-8", "results-hypo4-9");
                break;
            case "results-hypo4-9":
                textcontainer.select("#hypo4-cs-text").classed("p1",true);
                break;
            case "results-hypo4-10":
                pos = 4.5 * sep + 12 * width;
                d3.select("#hypo4-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",700);
                d3.select("#hypo4-endline")
                    .transition()
                    .attr("x1",700)
                    .attr("x2",700);
                container.append("g")
                    .attr("id","hypo4-nomathcs")
                    .attr("transform","translate("+(pos += width)+",0)");
                textcontainer.append("text")
                    .text("NoMathCS")
                    .attr("id","hypo4-nomathcs-text")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+40)
                    .style("text-anchor","middle");
                textcontainer.append("text")
                    .text("24")
                    .classed("disabled",true)
                    .attr("id","hypo4-nomathcs-resp")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+80)
                    .style("text-anchor","middle");
                textcontainer.append("text")
                    .text("336")
                    .classed("disabled",true)
                    .attr("id","hypo4-nomathcs-fu")
                    .attr("x",pos+(3*width/2))
                    .attr("y",height+120)
                    .style("text-anchor","middle");
                treestackchart("hypo4-nomathcs", "treeaesth_nomathcs.csv", width, height, 1, "results-hypo4-11", "results-hypo4-12");
                break;
            case "results-hypo4-12":
                textcontainer.select("#hypo4-nomathcs-text").classed("p1",true);
                break;
            case "results-hypo4-13":
                textcontainer.select("#hypo4-all-resp").classed("disabled",false);
                break;
            case "results-hypo4-14":
                textcontainer.select("#hypo4-mathcs-resp").classed("disabled",false);
                break;
            case "results-hypo4-15":
                textcontainer.select("#hypo4-math-resp").classed("disabled",false);
                textcontainer.select("#hypo4-cs-resp").classed("disabled",false);
                break;
            case "results-hypo4-16":
                textcontainer.select("#hypo4-nomathcs-resp").classed("disabled",false);
                break;
            case "results-hypo4-17":
                section.select("#hypo4-followup-text").classed("disabled",false);
                break;
            case "results-hypo4-18":
                var responses = section.select("#hypo4-responses").text(null);
                responses.append("tspan")
                    .text("Preference - ");
                responses.append("tspan")
                    .classed("strike",true)
                    .text("504");
                responses.append("tspan")
                    .text(" 1080 responses");
                textcontainer.select("#hypo4-all-resp").classed("strike",true);
                textcontainer.select("#hypo4-all-fu").classed("disabled",false);
                break;
            case "results-hypo4-19":
                textcontainer.select("#hypo4-mathcs-resp").classed("strike",true);
                textcontainer.select("#hypo4-mathcs-fu").classed("disabled",false);
                break;
            case "results-hypo4-20":
                textcontainer.select("#hypo4-math-resp").classed("strike",true);
                textcontainer.select("#hypo4-math-fu").classed("disabled",false);
                textcontainer.select("#hypo4-cs-resp").classed("strike",true);
                textcontainer.select("#hypo4-cs-fu").classed("disabled",false);
                break;
            case "results-hypo4-21":
                textcontainer.select("#hypo4-nomathcs-resp").classed("strike",true);
                textcontainer.select("#hypo4-nomathcs-fu").classed("disabled",false);
                break;
            case "results-hypo4-22":
                updateTreeChart("hypo4-all", "fu_all.csv", height, 1);
                updateTreeChart("hypo4-mathcs", "fu_mathcs.csv", height, 1);
                updateTreeChart("hypo4-math", "fu_math.csv", height, 1);
                updateTreeChart("hypo4-cs", "fu_cs.csv", height, 1);
                updateTreeChart("hypo4-nomathcs", "fu_nomathcs.csv", height, 1);
                break;
            case "results-hypo4-23":
                textcontainer.select("#hypo4-math-text").classed("p1",true);
                textcontainer.select("#hypo4-nomathcs-text").classed("p1",false);
                textcontainer.select("#hypo4-nomathcs-text").classed("p0",true);
                break;
            case "results-hypo4-24":
                section.select("#results-hypo4-title").style("opacity",0);
                var resdiv = section.append("div")
                    .attr("id","results-hypo4-result")
                    .style("overflow","auto")
                    .style("float","left")
                    .style("margin-left","110px")
                    .style("margin-top","-140px");
                var resbox = resdiv.append("div")
                    .attr("class","roundbox1");
                resbox.append("span")
                    .attr("class","hypothesistitle")
                    .text("H4: Result");
                resbox.append("br");
                resbox.append("div")
                    .style("float","left")
                    .style("text-align","right")
                    .style("margin-right","10px")
                    .html("Math/CS:<br/>Other:");
                resbox.append("div")
                    .attr("class","teletype")
                    .style("float","left")
                    .html("Tidier > FewSeg > Quad<br/>FewSeg > Tidier > Quad");
        }
    });


    Reveal.addEventListener( 'fragmenthidden', function( event ) {
        var id = event.fragment.getAttribute('id');
        switch (id) {
            case "results-hypo4-1":
                container.select("#hypo4-all").remove();
                textcontainer.select("#hypo4-all-text").remove();
                textcontainer.select("#hypo4-all-resp").remove();
                textcontainer.select("#hypo4-all-fu").remove();
                break;
            case "results-hypo4-3":
                textcontainer.select("#hypo4-all-text").classed("p1",false);
                break;
            case "results-hypo4-4":
                d3.select("#hypo4-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",180);
                d3.select("#hypo4-endline")
                    .transition()
                    .attr("x1",180)
                    .attr("x2",180);
                container.select("#hypo4-mathcs").remove();
                textcontainer.select("#hypo4-mathcs-text").remove();
                textcontainer.select("#hypo4-mathcs-resp").remove();
                textcontainer.select("#hypo4-mathcs-fu").remove();
                break;
            case "results-hypo4-6":
                textcontainer.select("#hypo4-mathcs-text").classed("p1",false);
                break;
            case "results-hypo4-7":
                d3.select("#hypo4-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",310);
                d3.select("#hypo4-endline")
                    .transition()
                    .attr("x1",310)
                    .attr("x2",310);
                container.select("#hypo4-math").remove();
                textcontainer.select("#hypo4-math-text").remove();
                textcontainer.select("#hypo4-math-resp").remove();
                textcontainer.select("#hypo4-math-fu").remove();
                container.select("#hypo4-cs").remove();
                textcontainer.select("#hypo4-cs-text").remove();
                textcontainer.select("#hypo4-cs-resp").remove();
                textcontainer.select("#hypo4-cs-fu").remove();
                break;
            case "results-hypo4-9":
                textcontainer.select("#hypo4-cs-text").classed("p1",false);
                break;
            case "results-hypo4-10":
                d3.select("#hypo4-scalelines")
                    .selectAll("line")
                    .transition()
                    .attr("x2",570);
                d3.select("#hypo4-endline")
                    .transition()
                    .attr("x1",570)
                    .attr("x2",570);
                container.select("#hypo4-nomathcs").remove();
                textcontainer.select("#hypo4-nomathcs-text").remove();
                textcontainer.select("#hypo4-nomathcs-resp").remove();
                textcontainer.select("#hypo4-nomathcs-fu").remove();
                break;
            case "results-hypo4-12":
                textcontainer.select("#hypo4-nomathcs-text").classed("p1",false);
                break;
            case "results-hypo4-13":
                textcontainer.select("#hypo4-all-resp").classed("disabled",true);
                break;
            case "results-hypo4-14":
                textcontainer.select("#hypo4-mathcs-resp").classed("disabled",true);
                break;
            case "results-hypo4-15":
                textcontainer.select("#hypo4-math-resp").classed("disabled",true);
                textcontainer.select("#hypo4-cs-resp").classed("disabled",true);
                break;
            case "results-hypo4-16":
                textcontainer.select("#hypo4-nomathcs-resp").classed("disabled",true);
                break;
            case "results-hypo4-17":
                section.select("#hypo4-followup-text").classed("disabled",true);
                break;
            case "results-hypo4-18":
                var responses = section.select("#hypo4-responses");
                responses.selectAll("tspan").remove();
                responses.text("Preference - 504 responses");
                textcontainer.select("#hypo4-all-resp").classed("strike",false);
                textcontainer.select("#hypo4-all-fu").classed("disabled",true);
                break;
            case "results-hypo4-19":
                textcontainer.select("#hypo4-mathcs-resp").classed("strike",false);
                textcontainer.select("#hypo4-mathcs-fu").classed("disabled",true);
                break;
            case "results-hypo4-20":
                textcontainer.select("#hypo4-math-resp").classed("strike",false);
                textcontainer.select("#hypo4-math-fu").classed("disabled",true);
                textcontainer.select("#hypo4-cs-resp").classed("strike",false);
                textcontainer.select("#hypo4-cs-fu").classed("disabled",true);
                break;
            case "results-hypo4-21":
                textcontainer.select("#hypo4-nomathcs-resp").classed("strike",false);
                textcontainer.select("#hypo4-nomathcs-fu").classed("disabled",true);
                break;
            case "results-hypo4-22":
                resetTreeChart("hypo4-all", "fu_all.csv", height, 1);
                resetTreeChart("hypo4-mathcs", "fu_mathcs.csv", height, 1);
                resetTreeChart("hypo4-math", "fu_math.csv", height, 1);
                resetTreeChart("hypo4-cs", "fu_cs.csv", height, 1);
                resetTreeChart("hypo4-nomathcs", "fu_nomathcs.csv", height, 1);
                break;
            case "results-hypo4-23":
                textcontainer.select("#hypo4-math-text").classed("p1",false);
                textcontainer.select("#hypo4-nomathcs-text").classed("p1",true);
                textcontainer.select("#hypo4-nomathcs-text").classed("p0",false);
                break;
            case "results-hypo4-24":
                section.select("#results-hypo4-title").style("opacity",1);
                section.select("#results-hypo4-result").remove();
        }
    });
}



